{
Copyright (C)2006 JesTheOnlyOne

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

{$WARN SYMBOL_PLATFORM OFF}
{$IFDEF debug}
	{$R+,I+,Q+}
{$ELSE}
	{$R-,I-,Q-}
{$ENDIF}
unit mainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Spin, Menus, StdActns, ActnList, iniFiles,
  AppEvnts, strUtils, math, masks;

resourcestring
	rsLoadLogError =	'Cannot load log: "%s"';
	rsLowID =			'LowID';
	rsDynIP =			'Dynamic IP';

var
	strEndULSession: string =			': Removing client from upload list: ';
	strULClient: string =				' Client: ';
	strTransferred: string =			' Transferred: ';
	strFile: string =					' File: ';
	strCompleted: string =				'Completed transfer';
	{ 06 may 07: eMule v0.48a+ support >>> }
	strRemoteCancelNew: string =		'Remote client cancelled transfer.';
	{ 06 may 07: eMule v0.48a+ support >>> }
	strRemoteCancel: string =			'Remote client canceled transfer.';
	strUploaded: string =				'QueueSessionPayload: ';
	strUploadedEnd: string =			' In';
	strState: string =					',';
	strSoftwareStart: string =			'(';
	strSoftwareEnd: string =			')';
	strLowID1: string =					'@';
	strLowID2: string =					'.';

	strUploading: string =				'Uploading/';
	strDownloading: string =			'Downloading/';

	strEndDLSession: string =			': Download session ended: ';
	strDLClient: string =				' User: ';
	strNewState: string =				' New State: ';
	strIn: string =						' in ';
	strOutOfPartReqs: string =			'The remote client decided to stop/complete the transfer (got OP_OutOfPartReqs).';
	strNNP: string =					'NNP. You don''t need any parts from this client.';
	strDownloaded: string =				'Payload: ';
	strDownloadedEnd: string =			', ';
	strDownloadCancelled: string =		'You cancelled the download. Sending OP_CANCELTRANSFER';

	{ units are language dependent
	  strB is always tested last, so " " is enough
	  this way, it should work as well with Bytes, KB, MB, GB than with Octets, Ko, Mo, Go, for example }
	strB: string =						' ';
	strKB: string =						' K';
	strMB: string =						' M';
	strGB: string =						' G'; { ?? }

	strEMule: string =					'eMule v*';
	strEDHybrid: string =				'edonkeyhybrid*';
	strEDonkey: string =				'eDonkey *';
	strAMule: string =					'aMule*';
	strMLDonkey: string =				'mldonkey*';
	strShareaza: string =				'shareaza*';
	strEMCompat: string =				'eMule compat*';
	strLphant: string =					'lphant*';

{ 07 may 07: Remembers last logs folder >>> }
var
	logFolder: string = 'c:\program files\eMule\logs\';
{ old code:
const
	logFolder = 'c:\program files\eMule\logs\';
}{ <<< 07 may 07: Remembers last logs folder }

const
	logName = 'eMule_Verbose.log';

type
	tSession = class( tObject )
		{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
		private
			procedure calcTransferredBytes; virtual; abstract;
		{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
		public
			state: string;
			transferred: string;
			fileName: string;
			{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
			transferredBytes: int64;
			{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
			constructor create( const aState, aTransferred, aFileName: string );
		end;

	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
	tUSession = class( tSession )
		private
			procedure calcTransferredBytes; override;
		end;

	tDSession = class( tSession )
		private
			procedure calcTransferredBytes; override;
		end;
	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }

	tID = record
		lowID: boolean;
		ID: dWord;
		IP: dWord;
		end;

	tSessions = class( tStringList )
		private
			{ 25 apr 07: Optimizations >>> }
			fClientPseudo: string;
			fClientSoftware: string;
			fClientIP: dWord;
			fClientID: tID;
			{ <<< 25 apr 07: Optimizations }
			fClientDynIP: boolean; { 20 may 07: Clients identification options }
			function getSession( index: integer ): tSession;
		public
			{ 25 apr 07: Optimizations >>> }
			constructor create( const clientStr: string );
{ old code:
			constructor create;
}			{ <<< 25 apr 07: Optimizations }
			destructor destroy; override;
			{ 25 apr 07: Optimizations >>> }
			function compare( sessions: tSessions ): integer;
			{ <<< 25 apr 07: Optimizations }
			procedure statistics( var completed, interrupted, failed: integer; var transferred: int64 ); virtual; abstract;
			property session[ index: integer ]: tSession read getSession;
			{ 25 apr 07: Optimizations >>> }
			property clientPseudo: string read fClientPseudo;
			property clientSoftware: string read fClientSoftware;
			property clientIP: dWord read fClientIP;
			property clientID: tID read fClientID;
			{ <<< 25 apr 07: Optimizations }
			property clientDynIP: boolean read fClientDynIP; { 20 may 07: Clients identification options }
		end;

	tUSessions = class( tSessions )
		public
			procedure statistics( var completed, interrupted, failed: integer; var transferred: int64 ); override;
		end;

	tDSessions = class( tSessions )
		public
			procedure statistics( var completed, interrupted, failed: integer; var transferred: int64 ); override;
		end;

	{ 25 apr 07: Optimizations >>> }
	tClients = class( tList )
{ old code:
	tClients = class( tStringList )
}	{ <<< 25 apr 07: Optimizations }
		private
			function getSessions( index: integer ): tSessions;
			{ 25 apr 07: Optimizations >>> }
			function createSessions( const s: string ): tSessions; virtual; abstract;
			function getID( index: integer ): tID;
			function getIP( index: integer ): dWord;
{ old code:
			function getID( index: integer ): string;
			function getIP( index: integer ): string;
			function getLowID( index: integer ): boolean;
}			{ <<< 25 apr 07: Optimizations }
			function getSoftware( index: integer ): string;
			function getPseudo( index: integer ): string;
			function getDynIP( index: integer ): boolean; { 20 may 07: Clients identification options }
		public
			{ 25 apr 07: Optimizations >>> }
{ old code:
			constructor create;
}			{ <<< 25 apr 07: Optimizations }
			destructor destroy; override;
			procedure clear; override;
			{ 25 apr 07: Optimizations >>> }
			function add( const s: string ): integer;
			function find( aSessions: tSessions; var index: integer ): boolean;
			{ <<< 25 apr 07: Optimizations }
			property sessions[ index: integer ]: tSessions read getSessions;
			{ 25 apr 07: Optimizations >>> }
			property ID[ index: integer ]: tID read getID;
			property IP[ index: integer ]: dWord read getIP;
{ old code:
			property ID[ index: integer ]: string read getID;
			property IP[ index: integer ]: string read getIP;
			property lowID[ index: integer ]: boolean read getLowID;
}			{ <<< 25 apr 07: Optimizations }
			property software[ index: integer ]: string read getSoftware;
			property pseudo[ index: integer ]: string read getPseudo;
			property dynIP[ index: integer ]: boolean read getDynIP; { 20 may 07: Clients identification options }
		end;

	{ 25 apr 07: Optimizations >>> }
	tUClients = class( tClients )
		private
			function createSessions( const s: string ): tSessions; override;
		end;

	tDClients = class( tClients )
		private
			function createSessions( const s: string ): tSessions; override;
		end;
	{ <<< 25 apr 07: Optimizations }

  tmainForm = class(TForm)
    uClientsBox: TListBox;
	uSessionsBox: TListBox;
    uStateBox: TEdit;
	Label1: TLabel;
	Label2: TLabel;
    uTransferredBox: TEdit;
	tabs: TPageControl;
	uClientsTab: TTabSheet;
	uStatsTab: TTabSheet;
    uBottomPanel: TPanel;
    uStatsSettingsPanel: TPanel;
	Label3: TLabel;
	uMinSessionsBox: TSpinEdit;
    Label4: TLabel;
    uStatsBox: TRichEdit;
    uIDBox: TRadioGroup;
    actions: TActionList;
    aFileOpen: TFileOpen;
    aFileExit: TFileExit;
	mainMenu: TMainMenu;
	File1: TMenuItem;
	Open1: TMenuItem;
	Exit1: TMenuItem;
    uRemoteCompleteBox: TCheckBox;
	Label5: TLabel;
	uFileBox: TEdit;
    aUNextSession: TAction;
    aUPrevSession: TAction;
	AppEvents: TApplicationEvents;
    uZeroBox: TCheckBox;
    dClientsTab: TTabSheet;
	dClientsBox: TListBox;
	dSessionsBox: TListBox;
	dBottomPanel: TPanel;
    Label6: TLabel;
	Label7: TLabel;
    dStateBox: TEdit;
	dTransferredBox: TEdit;
    dStatsTab: TTabSheet;
    dStatsSettingsPanel: TPanel;
    Label9: TLabel;
	Label10: TLabel;
	dMinSessionsBox: TSpinEdit;
    dIDBox: TRadioGroup;
    dNNPBox: TCheckBox;
    dZeroBox: TCheckBox;
    dStatsBox: TRichEdit;
    aDNextSession: TAction;
    aDPrevSession: TAction;
    noticePanel: TPanel;
    noticeBtn: TButton;
    noticeBox: TRichEdit;
    noNoticeBox: TCheckBox;
    uFilesBox: TListBox;
	Label8: TLabel;
    uSplitter: TSplitter;
    aHideFilters: TAction;
    Options1: TMenuItem;
    Hidefilters1: TMenuItem;
    progressBar: TProgressBar;
    uSoftBox: TComboBox;
	Label11: TLabel;
    Label12: TLabel;
    dSoftBox: TComboBox;
    RichEdit1: TRichEdit;
    RichEdit2: TRichEdit;
    aSortByIP: TAction;
	aSortByPseudo: TAction;
    aSortBySoftware: TAction;
    clientsMenu: TPopupMenu;
    SortbyIP1: TMenuItem;
	Sortbypseudonym1: TMenuItem;
    Sortbysoftware1: TMenuItem;
    uSelClientsBox: TCheckBox;
    dSelClientsBox: TCheckBox;
    aClientsIdOptions: TAction;
    Clientsidentification1: TMenuItem;
	procedure loadIni;
	procedure loadLog( const logPath: string; logList: tStrings = nil );
	procedure FormCreate(Sender: TObject);
	procedure uClientsBoxClick(Sender: TObject);
	procedure dClientsBoxClick(Sender: TObject);
	procedure FormDestroy(Sender: TObject);
	procedure uSessionsBoxClick(Sender: TObject);
	procedure dSessionsBoxClick(Sender: TObject);
	procedure FormShow(Sender: TObject);
	procedure calcStats( ul: boolean; progressMin: integer = 0; progressMax: integer = 100 );
	procedure aFileOpenAccept(Sender: TObject);
	procedure uUpdateStats(Sender: TObject);
	procedure dUpdateStats(Sender: TObject);
	procedure uMinSessionsBoxChange(Sender: TObject);
	procedure dMinSessionsBoxChange(Sender: TObject);
	procedure uPrevNextSessionUpdate(Sender: TObject);
	procedure aUNextSessionExecute(Sender: TObject);
	procedure aUPrevSessionExecute(Sender: TObject);
	procedure dPrevNextSessionUpdate(Sender: TObject);
	procedure aDNextSessionExecute(Sender: TObject);
	procedure aDPrevSessionExecute(Sender: TObject);
	procedure AppEventsShowHint(var HintStr: String; var CanShow: Boolean; var HintInfo: THintInfo);
	procedure tabsChange(Sender: TObject);
    procedure noticeBtnClick(Sender: TObject);
	procedure noticePanelInit;
	procedure noticePanelResize(Sender: TObject);
	procedure noNoticeBoxClick(Sender: TObject);
	procedure aHideFiltersExecute(Sender: TObject);
	procedure FormResize(Sender: TObject);
	procedure uSoftBoxChange(Sender: TObject);
	procedure dSoftBoxChange(Sender: TObject);
	procedure uSoftBoxKeyPress(Sender: TObject; var Key: Char);
	procedure dSoftBoxKeyPress(Sender: TObject; var Key: Char);
	procedure clientsBoxDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
	procedure aSortClients(Sender: TObject);
	procedure uStatsTabExit(Sender: TObject);
    procedure dStatsTabExit(Sender: TObject);
    procedure uStatsTabEnter(Sender: TObject);
    procedure dStatsTabEnter(Sender: TObject);
    procedure aClientsIdOptionsExecute(Sender: TObject);
  private
  public
	uClients,
	dClients: tClients;
	uSessionsCount,
	dSessionsCount: integer;
	uStartTime,
	uEndTime,
	dStartTime,
	dEndTime: string;
	nextSessionShcut,
	prevSessionShcut: tShortcut;
	uFiles: tStringList;
	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
	totalUploaded,
	totalDownloaded: int64;
	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
  end;

var
	mainForm: tmainForm;
	calcTransfers: boolean;
	{ 23 apr 07: Optimizations >>> }
	formatSettingsUS: tFormatSettings;           
	{ <<< 23 apr 07: Optimizations }

{ 20 may 07: Clients identification options >>> }
var
	replaceRndCharsWithXXX: boolean;
	minRndChars,
	maxRndChars: integer;
	replaceRndCharsExceptions: tStringList;
	replaceLowID: boolean;
	dynIPDetection: boolean; { is dynIP detection option enabled ? }
	dynIPDetected: boolean; { The two compared sessions belong to the same client, with a different IP }
	dynIPDetectionDone: boolean; { must be false when creating the clients list, true when sorting the clients list }
	uselessPseudos: tStringList;
	significantSize: integer;

const
	defReplRndCharsException = '[Div.Co.iL][DreaMule][emule*][ePlus][FunnyNick][Li()Network*][ShareManga][VeryCD]';
	defUselessPseudos = '19[0-9][0-9] 20[0-9][0-9] amule* emule* http* Network* v[0-9]* vmule www* yourname';
{ <<< 20 may 07: Clients identification options }

implementation

uses licenseUnit, clientsIdOptionsUnit;

{$R *.dfm}
function unicodeFileToString( const path: string ): string;
var
	f: tFileStream;
	ws: pWideChar;
	l: int64;
	b: boolean;
begin
	b := false;
	result := '';
	if fileExists( path ) then
		begin
		try
			f := tFileStream.create( path, fmOpenRead or fmShareDenyNone );
			try
				l := f.size;
				getMem( ws, l + 2 );
				try
					{ 23 apr 07: Optimizations >>> }
					ws[ l div 2 ] := #0;
{ old code:
					fillChar( ws^, l + 2, 0 );
}					{ <<< 23 apr 07: Optimizations }
					f.read( ws^, l );
					{ 23 apr 07: Optimizations >>> }
					{ it's useless to remove the extra ? first character here } 
					if (pWord( ws )^ = $FEFF) then result := wideCharToString( ws )
{ old code:
					if (pWord( ws )^ = $FEFF) then result := copy( wideCharToString( ws ), 2, maxInt )
}					{ <<< 23 apr 07: Optimizations }
					else result := pChar( ws );
					b := true;
					finally freeMem( ws );
					end;
				finally f.free;
				end;
			except ;
			end;
		end;
	if not b then raise( exception.createFmt( rsLoadLogError, [path] ) );
end;

constructor tSession.create( const aState, aTransferred, aFileName: string );
begin
	inherited create;
	state := aState;
	transferred := aTransferred;
	fileName := aFileName;
	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
	calcTransferredBytes;
	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
end;

{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
procedure tUSession.calcTransferredBytes;
var
	s: string;
	p, p1: integer;
	d: double;
	m: int64;
begin
	m := 1;
	s := transferred;
	p := pos( strUploaded, s );
	s := copy( s, p + length( strUploaded ), maxInt );
	if calcTransfers then
		begin
		p := pos( strUploadedEnd, s );
		p1 := pos( strKB, s );
		if (p1 > 0) and (p1 < p) then
			m := 1024
		else
			begin
			p1 := pos( strMB, s );
			if (p1 > 0) and (p1 < p) then
				m := 1024 * 1024
			else
				begin
				p1 := pos( strGB, s );
				if (p1 > 0) and (p1 < p) then
					m := 1024 * 1024 * 1024
				else
					begin
					p1 := pos( strB, s );
					if (p1 > 0) and (p1 < p) then
						m := 1
					else
						p1 := 0;
					end;
				end;
			end;
		end
	else
		p1 := 0;
	if p1 = 0 then
		begin
		calcTransfers := false;
		p := pos( ' ', s );
		if copy( s, 1, pred( p ) ) = '0' then transferredBytes := 0 else transferredBytes := -1;
		end
	else
		begin
		s := copy( s, 1, pred( p1 ) );
		d := strToFloat( s, formatSettingsUS );
		transferredBytes := round( d * m );
		end;
end;

procedure tDSession.calcTransferredBytes;
var
	s: string;
	p, p1: integer;
	d: double;
	m: int64;
begin
	m := 1;
	s := transferred;
	p := pos( strDownloaded, s );
	s := copy( s, p + length( strDownloaded ), maxInt );
	if calcTransfers then
		begin
		p := pos( strDownloadedEnd, s );
		p1 := pos( strKB, s );
		if (p1 > 0) and (p1 < p) then
			m := 1024
		else
			begin
			p1 := pos( strMB, s );
			if (p1 > 0) and (p1 < p) then
				m := 1024 * 1024
			else
				begin
				p1 := pos( strGB, s );
				if (p1 > 0) and (p1 < p) then
					m := 1024 * 1024 * 1024
				else
					begin
					p1 := pos( strB, s );
					if (p1 > 0) and (p1 < p) then
						m := 1
					else
						p1 := 0;
					end;
				end;
			end;
		end
	else
		p1 := 0;
	if p1 = 0 then
		begin
		calcTransfers := false;
		p := pos( ' ', s );
		if copy( s, 1, pred( p ) ) = '0' then transferredBytes := 0 else transferredBytes := -1;
		end
	else
		begin
		s := copy( s, 1, pred( p1 ) );
		d := strToFloat( s, formatSettingsUS );
		transferredBytes := round( d * m );
		end;
end;
{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }

{ 25 apr 07: Optimizations >>> }
constructor tSessions.create( const clientStr: string );

	function getPseudo: string;
	var
		p, p1: integer;
		b: boolean;
		i: integer;
		s: string;
	begin
		if clientStr = '' then
			begin
			result := '';
			exit;
			end;
		p := pos( strLowID1, clientStr );
		if (p > 0) and (p < pos( strLowID2, clientStr )) then
			begin
			p := pos( ' ', clientStr );
			p1 := posEx( ' ', clientStr, succ( p ) );
			result := copy( clientStr, p1 + 2, length( clientStr ) - length( fClientSoftware ) - p1 - 5 );
			end
		else
			begin
			p1 := pos( ' ', clientStr );
			result := copy( clientStr, p1 + 2, length( clientStr ) - length( fClientSoftware ) - p1 - 5 );
			end;

		{ 20 may 07: Clients identification options >>> }
		if replaceRndCharsWithXXX then
			begin
			p1 := 0;
			repeat
				p := posEx( '[', result, succ( p1 ) );
				if p = 0 then break;
				p1 := posEx( ']', result, succ( p ) );
				if p1 = 0 then break;
				if (pred( p1 - p ) < minRndChars) or (pred( p1 - p ) > maxRndChars) then continue;
				b := false;
				s := copy( result, succ( p ), pred( p1 - p ) );
				for i := 0 to pred( replaceRndCharsExceptions.count ) do
					if matchesMask( s, replaceRndCharsExceptions[ i ] ) then
						begin
						b := true;
						break;
						end;
				if b then continue;
//				if not ansiContainsText( replaceRndCharsExceptions, copy( result, p, succ( p1 - p ) ) ) then
//				s := '*' + copy( result, p, succ( p1 - p ) ) + '*';
//				if not matchesMask( replaceRndCharsExceptions, s ) then
					fillChar( result[ succ( p ) ], pred( p1 - p ), 'x' );
			until false;
			end;
		{ <<< 20 may 07: Clients identification options }
	end;

	function getSoftware: string;
	var
		p, p1: integer;
		s1: string;
	begin
		if clientStr = '' then
			begin
			result := '';
			exit;
			end;
		s1 := copy( clientStr, 1, pred( length( clientStr ) ) );
		repeat
			p1 := lastDelimiter( strSoftwareEnd, s1 );
			p := lastDelimiter( strSoftwareStart, s1 );
			if (p1 > 0) and (p > 0) and (p < p1) then s1 := copy( s1, 1, pred( p ) );
		until (p = 0) or (p1 = 0) or (p > p1);
		if p < 0 then
			result := ''
		else
			result := copy( clientStr, succ( p ), length( clientStr ) - p - 1 );
	end;

	function getIP: dWord;
	var
		p, p1: integer;
		s: string;
	begin
		{ 14 may 07: bug fix: "" is not an integer value error when clicking in the files list in the UL stats tab >>> }
		if clientStr = '' then
			begin
			result := 0;
			exit;
			end;
		{ <<< 14 may 07: bug fix: "" is not an integer value error when clicking in the files list in the UL stats tab }
		p := pos( strLowID1, clientStr );
		if (p > 0) and (p < pos( strLowID2, clientStr )) then
			begin
			p := pos( ' ', clientStr );
			p1 := posEx( ' ', clientStr, succ( p ) );
			s := copy( clientStr, p + 2, p1 - p - 3 );
			end
		else
			begin
			p := pos( ' ', clientStr );
			s := copy( clientStr, 1, pred( p ) );
			end;
		result := 0;
		p1 := 1;
		repeat
			p := posEx( '.', s, p1 );
			if p = 0 then result := (result shL 8) or dWord( strToInt( copy( s, p1, maxInt ) ) )
			else result := (result shL 8) or dWord( strToInt( copy( s, p1, p - p1 ) ) );
			p1 := succ( p );
		until p = 0;
	end;

	function getID: tID;
	var
		p, p1, p2: integer;
	begin
		{ 14 may 07: bug fix: "" is not an integer value error when clicking in the files list in the UL stats tab >>> }
		if clientStr = '' then
			begin
			fillChar( result, sizeOf( result ), 0 );
			exit;
			end;
		{ <<< 14 may 07: bug fix: "" is not an integer value error when clicking in the files list in the UL stats tab }
		p := pos( strLowID1, clientStr );
		if (p > 0) and (p < pos( strLowID2, clientStr )) then
			begin
			result.lowID := true;
			{ 20 may 07: Clients identification options >>> }
			if replaceLowID then
				begin
				result.ID := 0;
				result.IP := 0;
				exit;
				end;
			{ <<< 20 may 07: Clients identification options }
			result.ID := strToInt64( copy( clientStr, 1, pred( p ) ) );
			p2 := posEx( ' ', clientStr, succ( p ) );
			result.IP := 0;
			p1 := succ( p );
			repeat
				p := posEx( '.', clientStr, p1 );
				if (p = 0) or (p > p2) then result.IP := (result.IP shL 8) or dWord( strToInt( copy( clientStr, p1, p2 - p1 ) ) )
				else result.IP := (result.IP shL 8) or dWord( strToInt( copy( clientStr, p1, p - p1 ) ) );
				p1 := succ( p );
			until (p = 0) or (p > p2);
			end
		else
			begin
			result.lowID := false;
			result.ID := 0;
			result.IP := 0;
			end;
	end;

begin
	inherited create;
	sorted := false;
	caseSensitive := false;
	fClientSoftware := getSoftware; { must be calculated before fClientPseudo }
	fClientPseudo := getPseudo; { must be calculated before fClientIP (20 may 07: Clients identification options) }
	fClientIP := getIP;
	fClientID := getID;
	fClientDynIP := false; { 20 may 07: Clients identification options }
end;
{ old code:
constructor tSessions.create;
begin
	inherited create;
	sorted := false;
	caseSensitive := false;
end;
}{ <<< 25 apr 07: Optimizations }

destructor tSessions.destroy;
var
	i: integer;
begin
	for i := 0 to pred( count ) do if objects[ i ] <> nil then objects[ i ].free;
	inherited destroy;
end;

function tSessions.getSession( index: integer ): tSession;
begin
	result := tSession( objects[ index ] );
end;

procedure tUSessions.statistics( var completed, interrupted, failed: integer; var transferred: int64 );
var
	i: integer;
	s: string;
	t: integer;
	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
{ old code:
	p, p1: integer;
	d: double;
	m: int64;
}	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
	{ 23 apr 07: Optimizations >>> }
{ old code:
	fs: tFormatSettings;
}	{ <<< 23 apr 07: Optimizations }
begin
	{ 23 apr 07: Optimizations >>> }
{ old code:
	getLocaleFormatSettings( $409, fs );
}	{ <<< 23 apr 07: Optimizations }
	completed := 0;
	interrupted := 0;
	failed := 0;
	transferred := 0;
	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
{ old code:
	m := 1;
}	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }

	for i := 0 to pred( count ) do
		begin
		{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
		t := session[ i ].transferredBytes;
		if t > 0 then transferred := transferred + t;
(* old code:
		s := session[ i ].transferred;
		p := pos( strUploaded, s );
		s := copy( s, p + length( strUploaded ), maxInt );
		if calcTransfers then
			begin
			p := pos( strUploadedEnd, s );
			p1 := pos( strKB, s );
			if (p1 > 0) and (p1 < p) then
				m := 1024
			else
				begin
				p1 := pos( strMB, s );
				if (p1 > 0) and (p1 < p) then
					m := 1024 * 1024
				else
					begin
					p1 := pos( strGB, s );
					if (p1 > 0) and (p1 < p) then
						m := 1024 * 1024 * 1024
					else
						begin
						p1 := pos( strB, s );
						if (p1 > 0) and (p1 < p) then
							m := 1
						else
							p1 := 0;
						end;
					end;
				end;
			end
		else
			p1 := 0;
		if p1 = 0 then
			begin
			calcTransfers := false;
			p := pos( ' ', s );
			if copy( s, 1, pred( p ) ) = '0' then t := 0 else t := 1;
			end
		else
			begin
			s := copy( s, 1, pred( p1 ) );
			{ 23 apr 07: Optimizations >>> }
			d := strToFloat( s, formatSettingsUS );
{ old code:
			d := strToFloat( s, fs );
}			{ <<< 23 apr 07: Optimizations }
			t := round( d * m );
			transferred := transferred + t;
			end;
*)		{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }

		s := strings[ i ];
		{ 06 may 07: eMule v0.48a+ support >>> }
		if (s = strCompleted) or ((s = strRemoteCancelNew) or (s = strRemoteCancel)) and mainForm.uRemoteCompleteBox.checked then
{ old code:
		if (s = strCompleted) or (s = strRemoteCancel) and mainForm.uRemoteCompleteBox.checked then
}		{ <<< 06 may 07: eMule v0.48a+ support }
			inc( completed )
		else if mainForm.uZeroBox.checked then
			begin
			if t = 0 then inc( failed )
			else inc( interrupted );
			end
		else
			begin
			s := session[ i ].state;
			if pos( strUploading, s ) > 1 then inc( interrupted )
			else inc( failed );
			end;
		end;
end;

procedure tDSessions.statistics( var completed, interrupted, failed: integer; var transferred: int64 );
var
	i: integer;
	s: string;
	t: integer;
	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
{ old code:
	p, p1: integer;
	d: double;
	m: int64;
}	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
	{ 23 apr 07: Optimizations >>> }
{ old code:
	fs: tFormatSettings;
}	{ <<< 23 apr 07: Optimizations }
begin
	{ 23 apr 07: Optimizations >>> }
{ old code:
	getLocaleFormatSettings( $409, fs );
}	{ <<< 23 apr 07: Optimizations }
	completed := 0;
	interrupted := 0;
	failed := 0;
	transferred := 0;
	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
{ old code:
	m := 1;
}	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }

	for i := 0 to pred( count ) do
		begin
		{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
		t := session[ i ].transferredBytes;
		if t > 0 then transferred := transferred + t;
(* old code:
		s := session[ i ].transferred;
		p := pos( strDownloaded, s );
		s := copy( s, p + length( strDownloaded ), maxInt );
		if calcTransfers then
			begin
			p := pos( strDownloadedEnd, s );
			p1 := pos( strKB, s );
			if (p1 > 0) and (p1 < p) then
				m := 1024
			else
				begin
				p1 := pos( strMB, s );
				if (p1 > 0) and (p1 < p) then
					m := 1024 * 1024
				else
					begin
					p1 := pos( strGB, s );
					if (p1 > 0) and (p1 < p) then
						m := 1024 * 1024 * 1024
					else
						begin
						p1 := pos( strB, s );
						if (p1 > 0) and (p1 < p) then
							m := 1
						else
							p1 := 0;
						end;
					end;
				end;
			end
		else
			p1 := 0;
		if p1 = 0 then
			begin
			calcTransfers := false;
			p := pos( ' ', s );
			if copy( s, 1, pred( p ) ) = '0' then t := 0 else t := 1;
			end
		else
			begin
			s := copy( s, 1, pred( p1 ) );
			{ 23 apr 07: Optimizations >>> }
			d := strToFloat( s, formatSettingsUS );
{ old code:
			d := strToFloat( s, fs );
}			{ <<< 23 apr 07: Optimizations }
			t := round( d * m );
			transferred := transferred + t;
			end;
*)		{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }

		s := strings[ i ];
		if (s = strOutOfPartReqs) or (s = strNNP) and mainForm.dNNPBox.checked then
			inc( completed )
		else if mainForm.dZeroBox.checked then
			begin
			if t = 0 then inc( failed )
			else inc( interrupted );
			end
		else
			begin
			s := session[ i ].state;
			if pos( strDownloading, s ) = 1 then inc( interrupted )
			else inc( failed );
			end;
		end;
end;

{ 25 apr 07: Optimizations >>> }
{ old code:
constructor tClients.create;
begin
	inherited create;
	sorted := true;
	caseSensitive := false;
	duplicates := dupIgnore;
end;
}{ <<< 25 apr 07: Optimizations }

procedure tClients.clear;
var
	i: integer;
begin
	{ 25 apr 07: Optimizations >>> }
	for i := 0 to pred( count ) do if items[ i ] <> nil then
		begin
		tObject( items[ i ] ).free;
		items[ i ] := nil;
		end;
{ old code:
	for i := 0 to pred( count ) do if objects[ i ] <> nil then
		begin
		objects[ i ].free;
		objects[ i ] := nil;
		end;
}	{ <<< 25 apr 07: Optimizations }
	inherited clear;
end;

{ 25 apr 07: Optimizations >>> }
destructor tClients.destroy;
begin
	clear;
	inherited destroy;
end;
{ old code:
destructor tClients.destroy;
var
	i: integer;
begin
	for i := 0 to pred( count ) do if objects[ i ] <> nil then objects[ i ].free;
	inherited destroy;
end;
}{ <<< 25 apr 07: Optimizations }

{ 25 apr 07: Optimizations >>> }
function tClients.add( const s: string ): integer;
var
	sessions: tSessions;
begin
	sessions := createSessions( s );
	if find( sessions, result ) then
		begin
		{ >>> 20 may 07: Clients identification options }
		if dynIPDetection then
			begin
			dynIPDetected := false;
			sessions.compare( getSessions( result ) );
			if dynIPDetected then
//				getSessions( result ).fClientIP := 0;
				getSessions( result ).fClientDynIP := true;
			end;
		{ <<< 20 may 07: Clients identification options }
		sessions.free;
		end
	else
		insert( result, sessions );
end;
{ <<< 25 apr 07: Optimizations }

{ 25 apr 07: Optimizations >>> }
function tClients.find( aSessions: tSessions; var index: integer ): boolean;
var
	L, H, I, C: Integer;
begin
	result := False;
	L := 0;
	H := count - 1;
	while L <= H do
		begin
		I := (L + H) shr 1;
		c := sessions[ i ].compare( aSessions );
		if C < 0 then
			L := I + 1
		else
			begin
			H := I - 1;
			if C = 0 then
				begin
				result := True;
				L := I;
				end;
			end;
		end;
	index := L;
end;
{ <<< 25 apr 07: Optimizations }

function tClients.getSessions( index: integer ): tSessions;
begin
	{ 25 apr 07: Optimizations >>> }
	result := tSessions( items[ index ] );
{ old code:
	result := tSessions( objects[ index ] );
}	{ <<< 25 apr 07: Optimizations }
end;

{ 25 apr 07: Optimizations >>> }
{ old code:
function tClients.getLowID( index: integer ): boolean;
var
	p: integer;
	client: string;
begin
	client := strings[ index ];
	p := pos( strLowID1, client );
	result := (p > 0) and (p < pos( strLowID2, client ));
end;
}{ <<< 25 apr 07: Optimizations }

{ 25 apr 07: Optimizations >>> }
function tClients.getSoftware( index: integer ): string;
begin
	if items[ index ] <> nil then result := sessions[ index ].clientSoftware else result := '';
end;
{ old code:
function tClients.getSoftware( index: integer ): string;
var
	p, p1: integer;
	s, s1: string;
begin
	s := strings[ index ];
	s1 := copy( s, 1, pred( length( s ) ) );
	repeat
		p1 := lastDelimiter( strSoftwareEnd, s1 );
		p := lastDelimiter( strSoftwareStart, s1 );
		if (p1 > 0) and (p > 0) and (p < p1) then s1 := copy( s1, 1, pred( p ) );
	until (p = 0) or (p1 = 0) or (p > p1);
	if p < 0 then
		result := ''
	else
		result := copy( s, succ( p ), length( s ) - p - 1 );
end;
}{ <<< 25 apr 07: Optimizations }

{ 25 apr 07: Optimizations >>> }
function tClients.getID( index: integer ): tID;
begin
	if items[ index ] <> nil then result := sessions[ index ].clientID else fillChar( result, sizeOf( result ), 0 );
end;
{ old code:
function tClients.getID( index: integer ): string;
var
	p: integer;
	client: string;
begin
	client := strings[ index ];
	p := pos( strLowID1, client );
	if (p > 0) and (p < pos( strLowID2, client )) then
		begin
		p := pos( ' ', client );
		result := copy( client, 1, pred( p ) );
		end
	else
		result := '';
end;
}{ <<< 25 apr 07: Optimizations }

{ 25 apr 07: Optimizations >>> }
function tClients.getIP( index: integer ): dWord;
begin
	if items[ index ] <> nil then result := sessions[ index ].clientIP else result := 0;
end;
{ old code:
function tClients.getIP( index: integer ): string;
var
	p, p1: integer;
	client: string;
begin
	client := strings[ index ];
	p := pos( strLowID1, client );
	if (p > 0) and (p < pos( strLowID2, client )) then
		begin
		p := pos( ' ', client );
		p1 := posEx( ' ', client, succ( p ) );
		result := copy( client, p + 2, p1 - p - 3 );
		end
	else
		begin
		p := pos( ' ', client );
		result := copy( client, 1, pred( p ) );
		end;
end;
}{ <<< 25 apr 07: Optimizations }

{ 20 may 07: Clients identification options >>> }
function tClients.getDynIP( index: integer ): boolean;
begin
	if items[ index ] <> nil then result := sessions[ index ].clientDynIP else result := false;
end;
{ <<< 20 may 07: Clients identification options }

{ 25 apr 07: Optimizations >>> }
function tClients.getPseudo( index: integer ): string;
begin
	if items[ index ] <> nil then result := sessions[ index ].clientPseudo else result := '';
end;
{ old code:
function tClients.getPseudo( index: integer ): string;
var
	p, p1: integer;
	client: string;
begin
	client := strings[ index ];
	p := pos( strLowID1, client );
	if (p > 0) and (p < pos( strLowID2, client )) then
		begin
		p := pos( ' ', client );
		p1 := posEx( ' ', client, succ( p ) );
		result := copy( client, p1 + 2, length( client ) - length( software[ index ] ) - p1 - 5 );
		end
	else
		begin
		p1 := pos( ' ', client );
		result := copy( client, p1 + 2, length( client ) - length( software[ index ] ) - p1 - 5 );
		end;
end;
}{ <<< 25 apr 07: Optimizations }

{ 25 apr 07: Optimizations >>> }
function tUClients.createSessions( const s: string ): tSessions;
begin
	result := tUSessions.create( s );
end;

function tDClients.createSessions( const s: string ): tSessions;
begin
	result := tDSessions.create( s );
end;
{ <<< 25 apr 07: Optimizations }

procedure tmainForm.loadIni;
var
	ini: tIniFile;
	softwares: tStringList;
	i: integer;
	s, s1: string;

	function doIt( const section, ident: string; var value: string; isSoftware: boolean = false ): string;
	begin
		if isSoftware and not ini.valueExists( section, ident ) then
			begin
			value := ini.readString( 'logStrings', ident, '"' + value + '"' );
			ini.deleteKey( 'logStrings', ident );
			end
		else
			value := ini.readString( section, ident, '"' + value + '"' );
		if copy( value, 1, 1 ) <> '"' then value := '"' + value + '"';
		if isSoftware and (pos( '?', value ) = 0) and (pos( '*', value ) = 0) then value := copy( value, 1, length( value ) - 1 ) + '*"';
		ini.writeString( section, ident, value );
		value := copy( value, 2, length( value ) - 2 );
		result := value;
	end;

begin
	ini := tIniFile.create( changeFileExt( application.exeName, '.ini' ) );
	try
		doIt( 'logStrings', 'EndULSession', strEndULSession );
		doIt( 'logStrings', 'ULClient', strULClient );
		doIt( 'logStrings', 'Transferred', strTransferred );
		doIt( 'logStrings', 'File', strFile );
		doIt( 'logStrings', 'Completed', strCompleted );
		{ 06 may 07: eMule v0.48a+ support >>> }
		doIt( 'logStrings', 'RemoteCancelNew', strRemoteCancelNew );
		{ 06 may 07: eMule v0.48a+ support >>> }
		doIt( 'logStrings', 'RemoteCancel', strRemoteCancel );
		doIt( 'logStrings', 'Uploaded', strUploaded );
		doIt( 'logStrings', 'UploadedEnd', strUploadedEnd );
		doIt( 'logStrings', 'State', strState );
		doIt( 'logStrings', 'SoftwareStart', strSoftwareStart );
		doIt( 'logStrings', 'SoftwareEnd', strSoftwareEnd );
		doIt( 'logStrings', 'LowID1', strLowID1 );
		doIt( 'logStrings', 'LowID2', strLowID2 );

		doIt( 'logStrings', 'Uploading', strUploading );
		doIt( 'logStrings', 'Downloading', strDownloading );

		doIt( 'logStrings', 'EndDLSession', strEndDLSession );
		doIt( 'logStrings', 'DLClient', strDLClient );
		doIt( 'logStrings', 'NewState', strNewState );
		doIt( 'logStrings', 'In', strIn );
		doIt( 'logStrings', 'OutOfPartReqs', strOutOfPartReqs );
		doIt( 'logStrings', 'NNP', strNNP );
		doIt( 'logStrings', 'Downloaded', strDownloaded );
		doIt( 'logStrings', 'DownloadedEnd', strDownloadedEnd );
		doIt( 'logStrings', 'DownloadCancelled', strDownloadCancelled );

		doIt( 'logStrings', 'B', strB );
		doIt( 'logStrings', 'KB', strKB );
		doIt( 'logStrings', 'MB', strMB );
		doIt( 'logStrings', 'GB', strGB );

		uSoftBox.items.add( '*' );
		uSoftBox.items.add( doIt( 'software', 'eMule', strEMule, true ) );
		uSoftBox.items.add( '!' + strEMule );
		uSoftBox.items.add( doIt( 'software', 'edHybrid', strEDHybrid, true ) );
		uSoftBox.items.add( doIt( 'software', 'eDonkey', strEDonkey, true ) );
		uSoftBox.items.add( doIt( 'software', 'aMule', strAMule, true ) );
		uSoftBox.items.add( doIt( 'software', 'mlDonkey', strMLDonkey, true ) );
		uSoftBox.items.add( doIt( 'software', 'shareaza', strShareaza, true ) );
		uSoftBox.items.add( doIt( 'software', 'eMCompat', strEMCompat, true ) );
		uSoftBox.items.add( doIt( 'software', 'lphant', strLphant, true ) );
		softwares := tStringList.create;
		try
			softwares.sorted := false;
			softwares.caseSensitive := false;
			softwares.duplicates := dupIgnore;
			ini.readSection( 'software', softwares );
			for i := 0 to pred( softwares.count ) do
				begin
				s := softwares[ i ];
				if not sameText( s, 'eMule' ) and not sameText( s, 'edHybrid' )
				  and not sameText( s, 'eDonkey' ) and not sameText( s, 'aMule' )
				  and not sameText( s, 'mlDonkey' ) and not sameText( s, 'shareaza' )
				  and not sameText( s, 'eMCompat' ) and not sameText( s, 'lphant' ) then
					begin
					s1 := '';
					uSoftBox.items.add( doIt( 'software', s, s1 ) );
					end;
				end;
			finally softwares.free;
			end;
		uSoftBox.itemIndex := 0;
		dSoftBox.items.text := uSoftBox.items.text;
		dSoftBox.itemIndex := 0;

		if not ini.readBool( 'Options', 'Notice', true ) then noticePanel.visible := false;

		{ 07 may 07: Remembers last logs folder >>> }
		s := ini.readString( 'Options', 'logFolder', logFolder );
		if directoryExists( s ) then logFolder := s;
		{ <<< 07 may 07: Remembers last logs folder }

		{ 20 may 07: Clients identification options >>> }
		replaceRndCharsWithXXX := ini.readBool( 'ClientsIdOptions', 'ReplaceRndChars', true );
		minRndChars := ini.readInteger( 'ClientsIdOptions', 'minRndChars', 4 );
		maxRndChars := ini.readInteger( 'ClientsIdOptions', 'maxRndChars', 8 );
		s := ini.readString( 'ClientsIdOptions', 'Exceptions', defReplRndCharsException );
		replaceRndCharsExceptions.text := stringReplace( copy( s, 2, length( s ) - 2 ), '][', #13#10, [rfReplaceAll] );
		replaceLowID := ini.readBool( 'ClientsIdOptions', 'ReplaceLowID', true );
		dynIPDetection := ini.readBool( 'ClientsIdOptions', 'dynIPDetection', true );
		uselessPseudos.text := stringReplace( ini.readString( 'ClientsIdOptions', 'uselessPseudos', defUselessPseudos ), ' ', #13#10, [rfReplaceAll] );
		significantSize := ini.readInteger( 'ClientsIdOptions', 'significantSize', 4 );
		{ <<< 20 may 07: Clients identification options }

		finally ini.free;
		end;
end;

function sortLogs( list: tStringList; index1, index2: integer ): integer;
var
	d1, d2: integer;
begin
	{ 23 apr 07: bug fix >>> }
	if extractFileName( list[ index1 ] ) = 'eMule_Verbose.log' then
		result := 1
	else if extractFileName( list[ index2 ] ) = 'eMule_Verbose.log' then
		result := -1
	else
		begin
	{ <<< 23 apr 07: bug fix }
		d1 := fileAge( list[ index1 ] );
		d2 := fileAge( list[ index2 ] );
		if d1 < d2 then result := -1
		else if d1 > d2 then result := 1
		else result := 0;
	{ 23 apr 07: bug fix >>> }
		end;
	{ <<< 23 apr 07: bug fix }
end;

{ 25 apr 07: Optimizations >>> }
function tSessions.compare( sessions: tSessions ): integer;

	function compareID: integer;
	var
		ID2: tID;
		i: int64;
	begin
		ID2 := sessions.clientID;
		if clientID.lowID and not ID2.lowID then
			result := -1
		else if not clientID.lowID and ID2.lowID then
			result := 1
		else if not clientID.lowID and not ID2.lowID then
			result := 0
		else
			begin
			i := int64( clientID.IP ) - int64( ID2.IP );
			if i < 0 then result := -1
			else if i > 0 then result := 1
			else
				begin
				i := int64( clientID.ID ) - int64( ID2.ID );
				if i < 0 then result := -1
				else if i > 0 then result := 1
				else result := 0;
				end;
			end;
	end;

	function comparePseudo: integer;
	begin
		{ 20 may 07: bug fix: pseudo and software comparison is now case sensitive >>> }
		result := ansiCompareStr( clientPseudo, sessions.clientPseudo );
{ old code:
		result := ansiCompareText( clientPseudo, sessions.clientPseudo );
}		{ 20 may 07: bug fix: pseudo and software comparison is now case sensitive >>> }
	end;

	function compareSoftware: integer;
	begin
		{ 20 may 07: bug fix: pseudo and software comparison is now case sensitive >>> }
		result := ansiCompareStr( clientSoftware, sessions.clientSoftware );
{ old code:
		result := ansiCompareText( clientSoftware, sessions.clientSoftware );
}		{ 20 may 07: bug fix: pseudo and software comparison is now case sensitive >>> }
	end;

	function compareIP: integer;
	type
		tBrackets = array[0..1] of char;
		tBracketsList = array[0..4] of tBrackets;
	const
		bracketsList: tBracketsList = ( ( '(', ')' ), ( '[', ']' ), ( '{', '}' ), ( '<', '>' ), ( '', '' ) );
	var
		i: int64;
		s: string;
		p1, p2: integer;
		j, k: integer;
		sl: tStringList;
	begin
		i := int64( clientIP ) - int64( sessions.clientIP );
		{ 20 may 07: Clients identification options >>> }
		if dynIPDetection then
			begin
			if dynIPDetectionDone then
				begin
				if clientDynIP and not sessions.clientDynIP then
					begin
					result := -1;
					exit;
					end
				else if not clientDynIP and sessions.clientDynIP then
					begin
					result := 1;
					exit;
					end;
				end
			else if ((i <> 0) or clientDynIP or sessions.clientDynIP) and (comparePseudo = 0) and (compareSoftware = 0) and (compareID = 0) then
				begin
				s := clientPseudo;
				for j := 0 to high( bracketsList ) do
					begin
					p1 := 1;
					repeat
						p1 := posEx( bracketsList[ j ][ 0 ], s, p1 );
						if p1 = 0 then break;
						p2 := posEx( bracketsList[ j ][ 1 ], s, succ( p1 ) );
						if p2 = 0 then break;
						s := trimRight( copy( s, 1, pred( p1 ) ) ) + ' ' + trimLeft( copy( s, succ( p2 ), maxInt ) );
					until false;
					end;
				s := trim( s );
				if s <> '' then
					begin
					sl := tStringList.create;
					try
						sl.caseSensitive := false;
						sl.duplicates := dupIgnore;
						sl.sorted := true;
						sl.text := stringReplace( s, ' ', #13#10, [rfReplaceAll] );
						for j := pred( sl.count ) downTo 0 do
							begin
							s := sl[ j ];
							if length( s ) < significantSize then
								sl.delete( j )
							else for k := 0 to pred( uselessPseudos.count ) do
								begin
								if matchesMask( s, uselessPseudos[ k ] ) then
									begin
									sl.delete( j );
									break;
									end;
								end;
							end;
						if sl.count > 0 then
							begin
							if (i <> 0) then dynIPDetected := true;
							result := 0;
							exit;
							end;
						finally sl.free;
						end;
					end;
				end;
			end;
		{ <<< 20 may 07: Clients identification options }
		if i < 0 then result := -1
		else if i > 0 then result := 1
		else result := 0;
	end;

begin
	if (mainForm.aSortByIP.tag > mainForm.aSortByPseudo.tag) and (mainForm.aSortByIP.tag > mainForm.aSortBySoftware.tag) then
		result := compareIP
	else if (mainForm.aSortByPseudo.tag > mainForm.aSortByIP.tag) and (mainForm.aSortByPseudo.tag > mainForm.aSortBySoftware.tag) then
		result := comparePseudo
	else
		result := compareSoftware;
	if result = 0 then
		begin
		if (mainForm.aSortByIP.tag > mainForm.aSortByPseudo.tag) and (mainForm.aSortByIP.tag < mainForm.aSortBySoftware.tag)
		  or (mainForm.aSortByIP.tag < mainForm.aSortByPseudo.tag) and (mainForm.aSortByIP.tag > mainForm.aSortBySoftware.tag) then
			result := compareIP
		else if (mainForm.aSortByPseudo.tag > mainForm.aSortByIP.tag) and (mainForm.aSortByPseudo.tag < mainForm.aSortBySoftware.tag)
		  or (mainForm.aSortByPseudo.tag < mainForm.aSortByIP.tag) and (mainForm.aSortByPseudo.tag > mainForm.aSortBySoftware.tag) then
			result := comparePseudo
		else
			result := compareSoftware;
		end;
	if result = 0 then
		begin
		if (mainForm.aSortByIP.tag < mainForm.aSortByPseudo.tag) and (mainForm.aSortByIP.tag < mainForm.aSortBySoftware.tag) then
			result := compareIP
		else if (mainForm.aSortByPseudo.tag < mainForm.aSortByIP.tag) and (mainForm.aSortByPseudo.tag < mainForm.aSortBySoftware.tag) then
			result := comparePseudo
		else
			result := compareSoftware;
		end;
	if result = 0 then
		result := compareID;
end;
{ <<< 25 apr 07: Optimizations }

{ 25 apr 07: Optimizations >>> }
function sortClients( item1, item2: pointer ): integer;
begin
	result := tSessions( item1 ).compare( tSessions( item2 ) )
end;
{ old code:
function sortClients( list: tStringList; index1, index2: integer ): integer;

	function compareIP: integer;
	var
		s1, s2: string;
		i: integer;
		p1, p2, p3, p4: integer;
	begin
		s1 := tClients( list ).IP[ index1 ];
		s2 := tClients( list ).IP[ index2 ];
		p1 := 0;
		p2 := 0;
		for i := 0 to 3 do
			begin
			if i < 3 then
				begin
				p3 := posEx( '.', s1, succ( p1 ) );
				p4 := posEx( '.', s2, succ( p2 ) );
				end
			else
				begin
				p3 := succ( length( s1 ) );
				p4 := succ( length( s2 ) );
				end;
			result := strToInt( copy( s1, succ( p1 ), p3 - p1 - 1 ) ) - strToInt( copy( s2, succ( p2 ), p4 - p2 - 1 ) );
			if result <> 0 then exit;
			p1 := p3;
			p2 := p4;
			end;
	end;

	function compareID: integer;
	var
		s1, s2: string;
		i: integer;
		p1, p2, p3, p4: integer;
		k: char;
	begin
		s1 := tClients( list ).ID[ index1 ];
		s2 := tClients( list ).ID[ index2 ];
		if (s1 <> '') and (s2 = '') then
			result := -1
		else if (s1 = '') and (s2 <> '') then
			result := 1
		else if (s1 = '') and (s2 = '') then
			result := 0
		else
			begin
			p1 := 0;
			p2 := 0;
			k := strLowID1[ 1 ];
			for i := 0 to 4 do
				begin
				if i < 4 then
					begin
					p3 := posEx( k, s1, succ( p1 ) );
					p4 := posEx( k, s2, succ( p2 ) );
					end
				else
					begin
					p3 := succ( length( s1 ) );
					p4 := succ( length( s2 ) );
					end;
				result := strToInt( copy( s1, succ( p1 ), p3 - p1 - 1 ) ) - strToInt( copy( s2, succ( p2 ), p4 - p2 - 1 ) );
				if result <> 0 then exit;
				p1 := p3;
				p2 := p4;
				k := '.';
				end;
			end;
	end;

	function comparePseudo: integer;
	begin
		result := ansiCompareText( tClients( list ).pseudo[ index1 ], tClients( list ).pseudo[ index2 ] );
	end;

	function compareSoftware: integer;
	begin
		result := ansiCompareText( tClients( list ).software[ index1 ], tClients( list ).software[ index2 ] );
	end;

begin
	if (mainForm.aSortByIP.tag > mainForm.aSortByPseudo.tag) and (mainForm.aSortByIP.tag > mainForm.aSortBySoftware.tag) then
		result := compareIP
	else if (mainForm.aSortByPseudo.tag > mainForm.aSortByIP.tag) and (mainForm.aSortByPseudo.tag > mainForm.aSortBySoftware.tag) then
		result := comparePseudo
	else
		result := compareSoftware;
	if result = 0 then
		begin
		if (mainForm.aSortByIP.tag > mainForm.aSortByPseudo.tag) and (mainForm.aSortByIP.tag < mainForm.aSortBySoftware.tag) or (mainForm.aSortByIP.tag < mainForm.aSortByPseudo.tag) and (mainForm.aSortByIP.tag > mainForm.aSortBySoftware.tag) then
			result := compareIP
		else if (mainForm.aSortByPseudo.tag > mainForm.aSortByIP.tag) and (mainForm.aSortByPseudo.tag < mainForm.aSortBySoftware.tag) or (mainForm.aSortByPseudo.tag < mainForm.aSortByIP.tag) and (mainForm.aSortByPseudo.tag > mainForm.aSortBySoftware.tag) then
			result := comparePseudo
		else
			result := compareSoftware;
		end;
	if result = 0 then
		begin
		if (mainForm.aSortByIP.tag < mainForm.aSortByPseudo.tag) and (mainForm.aSortByIP.tag < mainForm.aSortBySoftware.tag) then
			result := compareIP
		else if (mainForm.aSortByPseudo.tag < mainForm.aSortByIP.tag) and (mainForm.aSortByPseudo.tag < mainForm.aSortBySoftware.tag) then
			result := comparePseudo
		else
			result := compareSoftware;
		end;
	if result = 0 then
		result := compareID;
end;
}{ <<< 25 apr 07: Optimizations }

procedure tmainForm.loadLog( const logPath: string; logList: tStrings = nil );
var
	sl: tStringList;
	log,
	uLog,
	dLog: tStringList;
	i: integer;
	s: string;
	p: integer;
	index: integer;
	sessions: tSessions;
	pClient,
	pTransferred,
	p1: integer;
	sMessage,
	sClient,
	sState,
	sTransferred,
	sFile: string;
	maxSessions: integer;
	cr: tCursor;
	uRatio: integer;
	c1, c2: pChar;
	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
	session: tSession;
	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
	{ 07 may 07: Remembers last logs folder >>> }
	ini: tIniFile;
	{ <<< 07 may 07: Remembers last logs folder }
	aSortByIPTag,
	aSortByPseudoTag,
	aSortBySoftwareTag: integer;
begin
	cr := screen.cursor;
	screen.cursor := crHourglass;
	try

	{ 20 may 07: Clients identification options >>> }
	dynIPDetectionDone := false;
	aSortByIPTag := aSortByIP.tag;
	aSortByIP.tag := 0;
	aSortByPseudoTag := aSortByPseudo.tag;
	aSortByPseudo.tag := 1;
	aSortBySoftwareTag := aSortBySoftware.tag;
	aSortBySoftware.tag := 2;
	{ <<< 20 may 07: Clients identification options }

	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
	calcTransfers := true;
	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }

	uFiles.clear;
	uClients.clear;
	dClients.clear;
	{ 25 apr 07: Optimizations >>> }
{ old code:
	uClients.sorted := true;
	dClients.sorted := true;
}	{ <<< 25 apr 07: Optimizations }

	uLog := tStringList.create;
	uLog.sorted := false;
	uLog.caseSensitive := false;
	dLog := tStringList.create;
	dLog.sorted := false;
	dLog.caseSensitive := false;

	uStartTime := '';
	dStartTime := '';
	uEndTime := '';
	dEndTime := '';

	try
		{ 23 apr 07: Optimizations >>> }
		log := tStringList.create;
		try
			log.sorted := false;
			log.caseSensitive := false;
		{ <<< 23 apr 07: Optimizations }

			{ Load the log file(s) }
			if logList = nil then
				begin
				s := unicodeFileToString( logPath );
				progressBar.position := 39;
				end
			else
				begin
				sl := tStringList.create;
				try
					sl.caseSensitive := false;
					sl.sorted := false;
					sl.assign( logList );
					sl.customSort( sortLogs );
					s := '';
					for i := 0 to pred( sl.count ) do
						begin
						{ 07 may 07: Remembers last logs folder >>> }
						if i = 0 then
							begin
							ini := tIniFile.create( changeFileExt( application.exeName, '.ini' ) );
							try
								logFolder := extractFilePath( sl[ i ] );
								ini.writeString( 'Options', 'logFolder', logFolder );
								finally ini.free;
								end;
							end;
						{ <<< 07 may 07: Remembers last logs folder }
						s := s + unicodeFileToString( sl[ i ] );
						progressBar.position := succ( i ) * 39 div sl.count;
						end;
					finally sl.free;
					end;
				end;
			{ 23 apr 07: Optimizations >>> }
			log.text := s;
{ old code:
			uLog.text := s;
}			{ <<< 23 apr 07: Optimizations }
			progressBar.position := 40;

			{ Copy End of DL session events to dLog list, and End of DL session events to uLog list }
			{ 23 apr 07: Optimizations >>> }
			for i := 0 to pred( log.count ) do
				begin
				s := log[ i ];
				p := pos( strEndULSession, s );
				if p > 0 then { end of UL session }
					begin
					{ save the date/time of the 1st and last "removing client..." events }
					if uLog.count = 0 then uStartTime := copy( s, 1, pred( p ) )
					else uEndTime := copy( s, 1, pred( p ) );
					{ trim the first part of the line (date/time + "removing client..."), and add to the upload log }
					uLog.add( copy( s, p + length( strEndULSession ), maxInt ) );
					end
				else { not an end of UL session }
					begin
					p := pos( strEndDLSession, s );
					if p <> 0 then { end of DL session }
						begin
						{ save the date/time of the 1st and last "Download session ended" events }
						if dLog.count = 0 then dStartTime := copy( s, 1, pred( p ) )
						else dEndTime := copy( s, 1, pred( p ) );
						{ trim the first part of the line (date/time + "Download session ended"), and add to the download log }
						dLog.add( copy( s, p + length( strEndDLSession ), maxInt ) );
						end;
					end;

				if (log.count div 20 > 0) and (i mod (log.count div 20) = 0) then
					progressBar.position := 40 + i * 20 div log.count;
				end;
(* old code:
			for i := pred( uLog.count ) downTo 0 do
				begin
				s := uLog[ i ];
				p := pos( strEndULSession, s );
				if p = 0 then { not an end of UL session }
					begin
					{ remove from upload log }
					uLog.delete( i );
					p := pos( strEndDLSession, s );
					if p <> 0 then { end of DL session }
						begin
						{ save the date/time of the 1st and last "Download session ended" events }
						if dLog.count = 0 then dEndTime := copy( s, 1, pred( p ) )
						else dStartTime := copy( s, 1, pred( p ) );
						{ trim the first part of the line (date/time + "Download session ended") }
						{ and insert to the download log }
						dLog.insert( 0, copy( s, p + length( strEndDLSession ), maxInt ) );
						end;
					end
				else { end of UL session }
					begin
					{ save the date/time of the 1st and last "removing client..." events }
					if i = pred( uLog.count ) then uEndTime := copy( s, 1, pred( p ) )
					else uStartTime := copy( s, 1, pred( p ) );
					{ trim the first part of the line (date/time + "removing client...") }
					uLog[ i ] := copy( s, p + length( strEndULSession ), maxInt );
					end;

				if (uLog.count div 20 > 0) and ((uLog.count - i) mod (uLog.count div 20) = 0) then
					progressBar.position := 40 + (uLog.count - i) * 20 div uLog.count;
				end;
*)			{ <<< 23 apr 07: Optimizations }

		{ 23 apr 07: Optimizations >>> }
			finally log.free;
			end;
		{ <<< 23 apr 07: Optimizations }

		{ save the total number of UL/DL sessions }
		uSessionsCount := uLog.count;
		dSessionsCount := dLog.count;
		if uSessionsCount + dSessionsCount > 0 then uRatio := uSessionsCount * 100 div (uSessionsCount + dSessionsCount) else uRatio := 1;

		{ 23 apr 07: Optimizations >>> }
		{ Remove extra first character left by wideCharToString conversion }
		if copy( dStartTime, 1, 1 ) = '?' then dStartTime := copy( dStartTime, 2, maxInt );
		if copy( dEndTime, 1, 1 ) = '?' then dEndTime := copy( dEndTime, 2, maxInt );
		if copy( uStartTime, 1, 1 ) = '?' then uStartTime := copy( uStartTime, 2, maxInt );
		if copy( uEndTime, 1, 1 ) = '?' then uEndTime := copy( uEndTime, 2, maxInt );
		{ <<< 23 apr 07: Optimizations }

		{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
		totalUploaded := 0;
		totalDownloaded := 0;
		{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }

		{ get UL sessions infos for each client }
		for i := 0 to pred( uLog.count ) do
			begin
			s := uLog[ i ];

			pClient := pos( strULClient, s );
			sMessage := copy( s, 1, pred( pClient ) );

			{ 23 apr 07: Optimizations >>> }
			pTransferred := posEx( strTransferred, s, pClient + length( strULClient ) );
{ old code:
			pTransferred := pos( strTransferred, s );
}			{ <<< 23 apr 07: Optimizations }
			sClient := copy( s, pClient + length( strULClient ), pTransferred - pClient - length( strULClient ) );
			p := lastDelimiter( strState, sClient );
			sState := copy( sClient, succ( p ), length( sClient ) - p - 1 );
			sClient := copy( sClient, 1, pred( p ) ) + strSoftwareEnd;

			sTransferred := copy( s, succ( pTransferred ), maxInt );
			p := pos( strFile, sTransferred );
			sFile := copy( sTransferred, p + length( strFile ), maxInt );
			sTransferred := copy( sTransferred, 1, pred( p ) );

			if sFile = '' then
				dec( uSessionsCount ) { ignore sessions which had ended because the file has been removed from shares }
			else
				begin
				{ 25 apr 07: Optimizations >>> }
				index := uClients.add( sClient ); { add if not found, return index otherwise }
				sessions := uClients.sessions[ index ];
(* old code:
				index := uClients.add( sClient ); { add if not found, return index otherwise (sorted + dupIgnore) }

				sessions := uClients.sessions[ index ];
				if sessions = nil then
					begin
					sessions := tUSessions.create;
					uClients.objects[ index ] := sessions;
					end;
*)				{ <<< 25 apr 07: Optimizations }

				{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
				session := tUSession.create( sState, sTransferred, sFile );
				sessions.addObject( sMessage, session );
				totalUploaded := totalUploaded + session.transferredBytes;
{ old code:
				sessions.addObject( sMessage, tSession.create( sState, sTransferred, sFile ) );
}				{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
				uFiles.add( sFile );
				end;

			if (20 * uRatio div 100 > 0) and (uLog.count div (20 * uRatio div 100) > 0) and (succ( i ) mod (uLog.count div (20 * uRatio div 100)) = 0) then
				progressBar.position := 60 + succ( i ) * (20 * uRatio div 100) div uLog.count;
			end;
		progressBar.position := 60 + 20 * uRatio div 100;
		{ 25 apr 07: Optimizations >>> }
		{ 20 may 07: Clients identification options >>> }
(* old code:
		uClientsBox.count := uClients.count; { uses a virtual list box, now }
*)		{ <<< 20 may 07: Clients identification options }
{ old code:
		uClients.sorted := false;
		uClients.customSort( sortClients );
		uClientsBox.items.assign( uClients );
}		{ <<< 25 apr 07: Optimizations }
		uFilesBox.items.assign( uFiles );
		progressBar.position := 60 + 30 * uRatio div 100;

		{ get DL sessions infos for each client }
		for i := 0 to pred( dLog.count ) do
			begin
			s := dLog[ i ];

			p := pos( strDLClient, s );
			sMessage := copy( s, 1, pred( p ) );
			s := copy( s, p + length( strDLClient ), maxInt );

			p := pos( strNewState, s );
			sTransferred := copy( s, succ( p ), maxInt );
			s := copy( s, 1, pred( p ) );

			p := pos( strIn, s );
			repeat
				p1 := posEx( strIn, s, succ( p ) );
				if p1 <> 0 then p := p1;
			until p1 = 0;
			s := copy( s, 1, pred( p ) );

			p := lastDelimiter( strState, s );
			sState := copy( s, succ( p ), length( s ) - p - 1 );
			sClient := copy( s, 1, pred( p ) ) + strSoftwareEnd;

			if sMessage = strDownloadCancelled then
				dec( dSessionsCount ) { ignore sessions which had ended because you cancelled the download }
			else
				begin
				{ 25 apr 07: Optimizations >>> }
				index := dClients.add( sClient ); { add if not found, return index otherwise }
				sessions := dClients.sessions[ index ];
(* old code:
				index := dClients.add( sClient ); { add if not found, return index otherwise (sorted + dupIgnore) }

				sessions := dClients.sessions[ index ];
				if sessions = nil then
					begin
					sessions := tDSessions.create;
					dClients.objects[ index ] := sessions;
					end;
*)				{ <<< 25 apr 07: Optimizations }

				{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
				session := tDSession.create( sState, sTransferred, '' );
				sessions.addObject( sMessage, session );
				totalDownloaded := totalDownloaded + session.transferredBytes;
{ old code:
				sessions.addObject( sMessage, tSession.create( sState, sTransferred, '' ) );
}				{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
				end;

			if (20 * (100 - uRatio) div 100 > 0) and (dLog.count div (20 * (100 - uRatio) div 100) > 0) and (succ( i ) mod (dLog.count div (20 * (100 - uRatio) div 100)) = 0) then
				progressBar.position := 60 + 30 * uRatio div 100 + succ( i ) * (20 * (100 - uRatio) div 100) div dLog.count;
			end;
		progressBar.position := 60 + 30 * uRatio div 100 + 20 * (100 - uRatio) div 100;
		{ 25 apr 07: Optimizations >>> }
		{ 20 may 07: Clients identification options >>> }
(* old code:
		dClientsBox.count := dClients.count; { uses a virtual list box, now }
*)		{ <<< 20 may 07: Clients identification options }
{ old code:
		dClients.sorted := false;
		dClients.customSort( sortClients );
		dClientsBox.items.assign( dClients );
}		{ <<< 25 apr 07: Optimizations }
		progressBar.position := 90;

		finally
			dLog.free;
			uLog.free;
		end;

	maxSessions := 1;
	for i := 0 to pred( uClients.count ) do
		begin
		sessions := uClients.sessions[ i ];
		if sessions.count > maxSessions then maxSessions := sessions.count;
		end;
	uMinSessionsBox.value := 1;
	uMinSessionsBox.maxValue := maxSessions;

	maxSessions := 1;
	for i := 0 to pred( dClients.count ) do
		begin
		sessions := dClients.sessions[ i ];
		if sessions.count > maxSessions then maxSessions := sessions.count;
		end;
	dMinSessionsBox.value := 1;
	dMinSessionsBox.maxValue := maxSessions;

	{ 20 may 07: Clients identification options >>> }
	aSortByIP.tag := aSortByIPTag;
	aSortByPseudo.tag := aSortByPseudoTag;
	aSortBySoftware.tag := aSortBySoftwareTag;
	dynIPDetectionDone := true; 
	uClients.sort( sortClients );
	uClientsBox.count := uClients.count;
	dClients.sort( sortClients );
	dClientsBox.count := dClients.count;
	{ <<< 20 may 07: Clients identification options }

	uClientsBoxClick( nil );
	if mainForm.visible and (tabs.activePageIndex = 0) then uClientsBox.setFocus;
	dClientsBoxClick( nil );
	if mainForm.visible and (tabs.activePageIndex = 2) then dClientsBox.setFocus;

	calcStats( true, 90, 90 + 10 * uRatio div 100 );
	calcStats( false, 90 + 10 * uRatio div 100, 100 );

	finally
		progressBar.position := 0;
		screen.cursor := cr;
	end;
end;

procedure tmainForm.FormCreate(Sender: TObject);
begin
	{ 23 apr 07: Optimizations >>> }
	getLocaleFormatSettings( $409, formatSettingsUS );
	{ <<< 23 apr 07: Optimizations }

	if not fileExists( changeFileExt( application.exeName, '.ini' ) ) then
		begin
		licenseForm := tLicenseForm.create( self );
		with licenseForm do
			begin
			try
				try
					licenseBox.lines.loadFromFile( extractFilePath( application.exeName ) + 'license.txt' );
					showModal;
					except application.messageBox( '"License.txt" not found', pChar( mainForm.caption ), mb_Ok or mb_IconWarning );
					end;
				finally free;
				end;
			end;

		noNoticeBox.visible := false;
		end;

	nextSessionShcut := aUNextSession.shortcut;
	prevSessionShcut := aUPrevSession.shortcut;

	{ 20 may 07: Clients identification options >>> }
	replaceRndCharsExceptions := tStringList.create;
	replaceRndCharsExceptions.caseSensitive := false;
	replaceRndCharsExceptions.sorted := true;
	replaceRndCharsExceptions.duplicates := dupIgnore;
	uselessPseudos := tStringList.create;
	uselessPseudos.caseSensitive := false;
	uselessPseudos.sorted := true;
	uselessPseudos.duplicates := dupIgnore;
	{ <<< 20 may 07: Clients identification options }

	loadIni;

	noticePanelInit;

	{ 22 apr 07: Stats for selected clients >>> }
	uClients := tUClients.create;
	dClients := tDClients.create;
{ old code:
	uClients := tClients.create;
	dClients := tClients.create;
}	{ <<< 22 apr 07: Stats for selected clients }

	uFiles := tStringList.create;
	uFiles.caseSensitive := false;
	uFiles.duplicates := dupIgnore;
	uFiles.sorted := true;

	if fileExists( logFolder + logName ) then
		begin
		aFileOpen.dialog.fileName := logFolder + logName;
		loadLog( logFolder + logName );
		end
	else
		begin
		if directoryExists( logFolder ) then aFileOpen.dialog.initialDir := logFolder;
		aFileOpen.execute;
		end;
end;

procedure tmainForm.FormDestroy(Sender: TObject);
begin
	uFiles.free;
	dClients.free;
	uClients.free;
	{ 20 may 07: Clients identification options >>> }
	replaceRndCharsExceptions.free;
	uselessPseudos.free;
	{ <<< 20 may 07: Clients identification options }
end;

procedure tmainForm.uClientsBoxClick(Sender: TObject);
begin
	if (uClientsBox.selCount > 0) and (uClientsBox.itemIndex >= 0) then
		begin
		uSessionsBox.items.assign( uClients.sessions[ uClientsBox.itemIndex ] );
		uSessionsBox.itemIndex := 0;
		end
	else
		uSessionsBox.items.clear;
	{ 22 apr 07: Stats for selected clients >>> }
	uClientsBox.tag := 1;
	{ <<< 22 apr 07: Stats for selected clients }
	uSessionsBoxClick( nil );
end;

procedure tmainForm.dClientsBoxClick(Sender: TObject);
begin
	if (dClientsBox.selCount > 0) and (dClientsBox.itemIndex >= 0) then
		begin
		dSessionsBox.items.assign( dClients.sessions[ dClientsBox.itemIndex ] );
		dSessionsBox.itemIndex := 0;
		end
	else
		dSessionsBox.items.clear;
	{ 22 apr 07: Stats for selected clients >>> }
	dClientsBox.tag := 1;
	{ <<< 22 apr 07: Stats for selected clients }
	dSessionsBoxClick( nil );
end;

procedure tmainForm.uSessionsBoxClick(Sender: TObject);
var
	session: tSession;
begin
	if uSessionsBox.itemIndex >= 0 then
		begin
		session := uClients.sessions[ uClientsBox.itemIndex ].session[ uSessionsBox.itemIndex ];
		uStateBox.text := session.state;
		uTransferredBox.text := session.transferred;
		uFileBox.text := session.fileName;
		end
	else
		begin
		uStateBox.text := '';
		uTransferredBox.text := '';
		uFileBox.text := '';
		end;
end;

procedure tmainForm.dSessionsBoxClick(Sender: TObject);
var
	session: tSession;
begin
	if dSessionsBox.itemIndex >= 0 then
		begin
		session := dClients.sessions[ dClientsBox.itemIndex ].session[ dSessionsBox.itemIndex ];
		dStateBox.text := session.state;
		dTransferredBox.text := session.transferred;
		end
	else
		begin
		dStateBox.text := '';
		dTransferredBox.text := '';
		end;
end;

procedure tmainForm.FormShow(Sender: TObject);
begin
	tabs.activePageIndex := 0;
end;

procedure tMainForm.calcStats( ul: boolean; progressMin: integer = 0; progressMax: integer = 100 );
var
	clients: tClients;
	idBox: tRadioGroup;
	softBox: tComboBox;
	statsBox: tRichEdit;
	sessionsCount: integer;
	minSessionsBox: tSpinEdit;
	cr: tCursor;

	function idFiltered( index: integer ): boolean;
	var
		lowID: boolean;
	begin
		{ 24 apr 07: Optimizations >>> }
		lowID := clients.ID[ index ].lowID;
{ old code:
		lowID := clients.lowID[ index ];
}		{ <<< 24 apr 07: Optimizations }
		result := (idBox.itemIndex = 1) and lowID or (idBox.itemIndex = 2) and not lowID;
	end;

	function softwareFiltered( index: integer ): boolean;
	var
		s, m: string;
	begin
		s := stringReplace( stringReplace( clients.software[ index ], '[', '{', [rfReplaceAll] ), ']', '}', [rfReplaceAll] );
		m := stringReplace( stringReplace( softBox.text, '[', '{', [rfReplaceAll] ), ']', '}', [rfReplaceAll] );
		if m = '' then m := '*';
		try
			if m[ 1 ] = '!' then result := matchesMask( s, copy( m, 2, maxInt ) )
			else result := not matchesMask( s, m );
			except result := true;
			end;
	end;

	procedure addText( const newText: string; style: tFontStyles = [] );
	var
		i: integer;
	begin
		for i := 0 to 7 do statsBox.paragraph.tab[ i ] := 80 * i;
		statsBox.selAttributes.style := style;
		statsBox.selText := newText;
	end;

type
	tStatistics = record
		clientsCount,
		completed,
		interrupted,
		failed: integer;
		transferred: int64;
		end;

var
	stats: array[0..5] of tStatistics;
	statIndex: integer;
	completedSessions,
	interruptedSessions,
	failedSessions: integer;
	clientIndex: integer;
	sessions: tSessions;
	clientsUsed,
	sessionsUsed: integer;
	nSessions,
	nClients: integer;
	transferredBytes,
	transferredTotal,
	transferredGroup: int64;
	p1, p2: double;
	i, p: integer;
	{ 22 apr 07: Stats for selected clients >>> }
	clientsBox: tListBox;
	selClientsBox: tCheckBox;
	selCount: integer;
	{ <<< 22 apr 07: Stats for selected clients }
	{ 23 apr 07: Optimizations >>> }
	selFilesCount: integer;
	{ <<< 23 apr 07: Optimizations }
	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
	transferred_all: int64;
	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
begin
	cr := screen.cursor;
	screen.cursor := crHourglass;
	try

	if ul then
		begin
		clients := uClients;
		{ 22 apr 07: Stats for selected clients >>> }
		clientsBox := uClientsBox;
		selClientsBox := uSelClientsBox;
		{ <<< 22 apr 07: Stats for selected clients }
		idBox := uIDBox;
		softBox := uSoftBox;
		statsBox := uStatsBox;
		sessionsCount := uSessionsCount;
		minSessionsBox := uMinSessionsBox;
		{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
		transferred_all := totalUploaded;
		{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
		end
	else
		begin
		clients := dClients;
		{ 22 apr 07: Stats for selected clients >>> }
		clientsBox := dClientsBox;
		selClientsBox := dSelClientsBox;
		{ <<< 22 apr 07: Stats for selected clients }
		idBox := dIDBox;
		softBox := dSoftBox;
		statsBox := dStatsBox;
		sessionsCount := dSessionsCount;
		minSessionsBox := dMinSessionsBox;
		{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
		transferred_all := totalDownloaded;
		{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
		end;

	{ 22 apr 07: Stats for selected clients >>> }
	clientsBox.tag := 0;
	{ <<< 22 apr 07: Stats for selected clients }

	fillChar( stats, sizeOf( stats ), 0 );

	clientsUsed := 0;
	sessionsUsed := 0;

	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
{ old code:
	calcTransfers := true;
}	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }

	{ 22 apr 07: Stats for selected clients >>> }
	selCount := clientsBox.selCount;
	{ <<< 22 apr 07: Stats for selected clients }

	{ 23 apr 07: Optimizations >>> }
	selFilesCount := uFilesBox.selCount;
	{ 24 apr 07: Optimizations >>> }
	if ul and (selFilesCount > 0) then sessions := tUSessions.create( '' ) else sessions := nil;
{ old code:
	if ul and (selFilesCount > 0) then sessions := tUSessions.create else sessions := nil;
}	{ <<< 24 apr 07: Optimizations }
{ old code:
	if ul then sessions := tUSessions.create else sessions := nil;
}	{ <<< 23 apr 07: Optimizations }

	try
		for clientIndex := 0 to pred( clients.count ) do
			begin

			{ 22 apr 07: Stats for selected clients >>> }
			if not selClientsBox.checked or (selCount <= 0) or clientsBox.selected[ clientIndex ] then
				begin
			{ <<< 22 apr 07: Stats for selected clients }

				{ 23 apr 07: Optimizations >>> }
				if ul and (selFilesCount > 0) then
{ old code:
				if ul then
}				{ <<< 23 apr 07: Optimizations }
					begin
					sessions.assign( clients.sessions[ clientIndex ] );
					{ 23 apr 07: Optimizations >>> }
{ old code:
					if uFilesBox.selCount > 0 then
}					{ <<< 23 apr 07: Optimizations }
						for i := pred( sessions.count ) downTo 0 do
							begin
							uFiles.find( sessions.session[ i ].fileName, p );
							if not uFilesBox.selected[ p ] then
								sessions.delete( i );
							end;
					end
				else
					sessions := clients.sessions[ clientIndex ];
				if (sessions.count >= minSessionsBox.value) and not idFiltered( clientIndex ) and not softwareFiltered( clientIndex ) then
					begin
					inc( clientsUsed );
					inc( sessionsUsed, sessions.count );

					sessions.statistics( completedSessions, interruptedSessions, failedSessions, transferredBytes );

					if completedSessions > 0 then
						begin
						if (interruptedSessions + failedSessions = 0) then statIndex := 0
						else if (failedSessions = 0) then statIndex := 1
						else statIndex := 2;
						end
					else
						begin
						if (failedSessions = 0) then statIndex := 3
						else if (interruptedSessions = 0) then statIndex := 5
						else statIndex := 4;
						end;

					with stats[ statIndex ] do
						begin
						inc( clientsCount );
						inc( completed, completedSessions );
						inc( interrupted, interruptedSessions );
						inc( failed, failedSessions );
						transferred := transferred + transferredBytes;
						end;
					end;

			{ 22 apr 07: Stats for selected clients >>> }
				end;
			{ <<< 22 apr 07: Stats for selected clients }

			if (progressMax - progressMin > 0) and (clients.count div (progressMax - progressMin) > 0) and (succ( clientIndex ) mod (clients.count div (progressMax - progressMin)) = 0) then
				{ 25 apr 07: bug fix >>> }
				progressBar.position := progressMin + (int64( succ( clientIndex ) ) * (progressMax - progressMin)) div clients.count;
{ old code:
				progressBar.position := progressMin + succ( clientIndex ) * (clients.count div (progressMax - progressMin)) div clients.count;
}				{ <<< 25 apr 07: bug fix }
			end;
		finally
			{ 23 apr 07: Optimizations >>> }
			if ul and (selFilesCount > 0) then
{ old code:
			if ul then
}			{ <<< 23 apr 07: Optimizations }
				begin
				sessions.clear;
				sessions.free;
				end;
		end;

	progressBar.position := progressMax;

	transferredTotal := stats[ 0 ].transferred + stats[ 1 ].transferred + stats[ 2 ].transferred + stats[ 3 ].transferred + stats[ 4 ].transferred + stats[ 5 ].transferred;

	statsBox.lines.clear;


	if ul then addText( format( 'statistics from %s to %s:'#13#10, [uStartTime, uEndTime] ), [fsBold, fsUnderline] )
	else addText( format( 'statistics from %s to %s:'#13#10, [dStartTime, dEndTime] ), [fsBold, fsUnderline] );

	addText( format( '%u clients'#13#10, [clients.count] ) );

	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
	if clients.count = 0 then addText( format( '%u sessions'#13#10, [sessionsCount] ) )
	else addText( format( '%u sessions	(%f per client)'#13#10, [sessionsCount, sessionsCount / clients.count] ) );
{ old code:
	if clients.count = 0 then addText( format( '%u sessions'#13#10#13#10, [sessionsCount] ) )
	else addText( format( '%u sessions	(%f per client)'#13#10#13#10, [sessionsCount, sessionsCount / clients.count] ) );
}	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }

	{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
	if clients.count > 0 then
		begin
		if calcTransfers then addText( format( '%fMB	(%fMB/client;	%fMB/session)'#13#10#13#10, [transferred_all / (1024 * 1024), (transferred_all / (1024 * 1024)) / clients.count, (transferred_all / (1024 * 1024)) / sessionsCount] ) )
		else addText( 'Cannot calculate the amount of transferred data (you may have to modify the units strings in "verbose analyser.ini" according to the language selected in eMule)'#13#10#13#10 );
		end;
	{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }


	addText( #9'Clients matching the selected settings:'#13#10, [fsBold] );
	if clientsUsed = 0 then
		addText( #9'None'#13#10 )
	else
		begin
		addText( format( '%f%%'#9'%u clients'#13#10, [100 * (clientsUsed / clients.count), clientsUsed] ) );
		addText( format( '%f%%'#9'%u sessions	(%f per client)'#13#10, [100 * (sessionsUsed / sessionsCount), sessionsUsed, sessionsUsed / clientsUsed] ) );
		{ 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients >>> }
		if transferred_all <> 0 then p1 := 100 * (transferredTotal / transferred_all) else p1 := nan;
		if calcTransfers then addText( format( '%f%%'#9'%fMB	(%fMB/client;	%fMB/session)'#13#10#13#10, [p1, transferredTotal / (1024 * 1024), (transferredTotal / (1024 * 1024)) / clientsUsed, (transferredTotal / (1024 * 1024)) / sessionsUsed] ) )
{ old code:
		if calcTransfers then addText( format( #9'%fMB	(%fMB/client;	%fMB/session)'#13#10#13#10, [transferredTotal / (1024 * 1024), (transferredTotal / (1024 * 1024)) / clientsUsed, (transferredTotal / (1024 * 1024)) / sessionsUsed] ) )
}		{ <<< 06 may 07: Show the total up/downloaded for all clients and the % of total for matching clients }
		else addText( 'Cannot calculate the amount of transferred data (you may have to modify the units strings in "verbose analyser.ini" according to the language selected in eMule)'#13#10#13#10 );

		addText( #9#9'Clients with at least one completed session:'#13#10, [fsBold] );
		nClients := stats[ 0 ].clientsCount + stats[ 1 ].clientsCount + stats[ 2 ].clientsCount;
		if nClients = 0 then
			addText( #9#9'None'#13#10#13#10 )
		else
			begin
			with stats[ 2 ] do nSessions := stats[ 0 ].completed + stats[ 1 ].completed + stats[ 1 ].interrupted + completed + interrupted + failed;
			addText( format( #9'%f%%'#9'%u clients'#13#10, [100 * (nClients / clientsUsed), nClients] ) );
			addText( format( #9'%f%%'#9'%u sessions	(%f per client)'#13#10, [100 * (nSessions / sessionsUsed), nSessions, nSessions / nClients ] ) );
			transferredGroup := stats[ 0 ].transferred + stats[ 1 ].transferred + stats[ 2 ].transferred;
			if calcTransfers then
				begin
				if transferredTotal <> 0 then p1 := 100 * (transferredGroup / transferredTotal) else p1 := nan;
				addText( format( #9'%f%%'#9'%fMB	(%fMB/client;	%fMB/session)'#13#10#13#10, [p1, transferredGroup / (1024 * 1024), (transferredGroup / (1024 * 1024)) / nClients, (transferredGroup / (1024 * 1024)) / nSessions] ) );
				end
			else
				addText( #13#10 );

			with stats[ 0 ] do
				begin
				addText( #9#9#9'Clients with only completed sessions:'#13#10, [fsBold] );
				if clientsCount = 0 then
					addText( #9#9#9'None'#13#10#13#10 )
				else
					begin
					addText( format( #9'%f%%'#9'%f%%'#9'%u clients'#13#10, [100 * (clientsCount / clientsUsed), 100 * (clientsCount / nClients), clientsCount] ) );
					addText( format( #9'%f%%'#9'%f%%'#9'%u sessions	(%f per client)'#13#10, [100 * (completed / sessionsUsed), 100 * (completed / nSessions), completed, completed / clientsCount ] ) );
					if calcTransfers then
						begin
						if transferredTotal <> 0 then p1 := 100 * (transferred / transferredTotal) else p1 := nan;
						if transferredGroup <> 0 then p2 := 100 * (transferred / transferredGroup) else p2 := nan;
						addText( format( #9'%f%%'#9'%f%%'#9'%fMB	(%fMB/client;	%fMB/session)'#13#10#13#10, [p1, p2, transferred / (1024 * 1024), (transferred / (1024 * 1024)) / clientsCount, (transferred / (1024 * 1024)) / completed] ) );
						end
					else
						addText( #13#10 );
					end;
				end;

			with stats[ 1 ] do
				begin
				addText( #9#9#9'Clients with both completed and interrupted sessions:'#13#10, [fsBold] );
				if clientsCount = 0 then
					addText( #9#9#9'None'#13#10#13#10 )
				else
					begin
					addText( format( #9'%f%%'#9'%f%%'#9'%u clients'#13#10, [100 * (clientsCount / clientsUsed), 100 * (clientsCount / nClients), clientsCount] ) );
					addText( format( #9'%f%%'#9'%f%%'#9'%u sessions	(%f per client)'#13#10, [100 * ((completed + interrupted) / sessionsUsed), 100 * ((completed + interrupted) / nSessions), completed + interrupted, (completed + interrupted) / clientsCount] ) );
					if calcTransfers then
						begin
						if transferredTotal <> 0 then p1 := 100 * (transferred / transferredTotal) else p1 := nan;
						if transferredGroup <> 0 then p2 := 100 * (transferred / transferredGroup) else p2 := nan;
						addText( format( #9'%f%%'#9'%f%%'#9'%fMB	(%fMB/client;	%fMB/session)'#13#10, [p1, p2, transferred / (1024 * 1024), (transferred / (1024 * 1024)) / clientsCount, (transferred / (1024 * 1024)) / (completed + interrupted)] ) );
						end;
					addText( format( #9#9#9'%f%%'#9'Completed:	%u sessions	(%f per client)'#13#10, [100 * (completed / (completed + interrupted)), completed, completed / clientsCount] ) );
					addText( format( #9#9#9'%f%%'#9'Interrupted:	%u sessions	(%f per client)'#13#10#13#10, [100 * (interrupted / (completed + interrupted)), interrupted, interrupted / clientsCount] ) );
					end;
				end;

			with stats[ 2 ] do
				begin
				addText( #9#9#9'Clients with both completed and failed (and possibly interrupted) sessions:'#13#10, [fsBold] );
				if clientsCount = 0 then
					addText( #9#9#9'None'#13#10#13#10 )
				else
					begin
					addText( format( #9'%f%%'#9'%f%%'#9'%u clients'#13#10, [100 * (clientsCount / clientsUsed), 100 * (clientsCount / nClients), clientsCount] ) );
					addText( format( #9'%f%%'#9'%f%%'#9'%u sessions	(%f per client)'#13#10, [100 * ((completed + interrupted + failed) / sessionsUsed), 100 * ((completed + interrupted + failed) / nSessions), completed + interrupted + failed, (completed + interrupted + failed) / clientsCount] ) );
					if calcTransfers then
						begin
						if transferredTotal <> 0 then p1 := 100 * (transferred / transferredTotal) else p1 := nan;
						if transferredGroup <> 0 then p2 := 100 * (transferred / transferredGroup) else p2 := nan;
						addText( format( #9'%f%%'#9'%f%%'#9'%fMB	(%fMB/client;	%fMB/session)'#13#10, [p1, p2, transferred / (1024 * 1024), (transferred / (1024 * 1024)) / clientsCount, (transferred / (1024 * 1024)) / (completed + interrupted + failed)] ) );
						end;
					addText( format( #9#9#9'%f%%'#9'Completed:	%u sessions	(%f per client)'#13#10, [100 * (completed / (completed + interrupted + failed)), completed, completed / clientsCount] ) );
					addText( format( #9#9#9'%f%%'#9'Interrupted:	%u sessions	(%f per client)'#13#10, [100 * (interrupted / (completed + interrupted + failed)), interrupted, interrupted / clientsCount] ) );
					addText( format( #9#9#9'%f%%'#9'Failed:	%u sessions	(%f per client)'#13#10#13#10, [100 * (failed / (completed + interrupted + failed)), failed, failed / clientsCount] ) );
					end;
				end;
			end;

		addText( #9#9'Clients without a single completed session:'#13#10, [fsBold] );
		nClients := stats[ 3 ].clientsCount + stats[ 4 ].clientsCount + stats[ 5 ].clientsCount;
		if nClients = 0 then
			addText( #9#9'None'#13#10#13#10 )
		else
			begin
			with stats[ 4 ] do nSessions := stats[ 3 ].interrupted + interrupted + failed + stats[ 5 ].failed;
			addText( format( #9'%f%%'#9'%u clients'#13#10, [100 * (nClients / clientsUsed), nClients] ) );
			addText( format( #9'%f%%'#9'%u sessions	(%f per client)'#13#10, [100 * (nSessions / sessionsUsed), nSessions, nSessions / nClients ] ) );
			transferredGroup := stats[ 3 ].transferred + stats[ 4 ].transferred + stats[ 5 ].transferred;
			if calcTransfers then
				begin
				if transferredTotal <> 0 then p1 := 100 * (transferredGroup / transferredTotal) else p1 := nan;
				addText( format( #9'%f%%'#9'%fMB	(%fMB/client;	%fMB/session)'#13#10#13#10, [p1, transferredGroup / (1024 * 1024), (transferredGroup / (1024 * 1024)) / nClients, (transferredGroup / (1024 * 1024)) / nSessions] ) );
				end
			else
				addText( #13#10 );

			with stats[ 3 ] do
				begin
				addText( #9#9#9'Clients whith only interrupted sessions:'#13#10, [fsBold] );
				if clientsCount = 0 then
					addText( #9#9#9'None'#13#10#13#10 )
				else
					begin
					addText( format( #9'%f%%'#9'%f%%'#9'%u clients'#13#10, [100 * (clientsCount / clientsUsed), 100 * (clientsCount / nClients), clientsCount] ) );
					addText( format( #9'%f%%'#9'%f%%'#9'%u sessions	(%f per client)'#13#10, [100 * (interrupted / sessionsUsed), 100 * (interrupted / nSessions), interrupted, interrupted / clientsCount] ) );
					if calcTransfers then
						begin
						if transferredTotal <> 0 then p1 := 100 * (transferred / transferredTotal) else p1 := nan;
						if transferredGroup <> 0 then p2 := 100 * (transferred / transferredGroup) else p2 := nan;
						addText( format( #9'%f%%'#9'%f%%'#9'%fMB	(%fMB/client;	%fMB/session)'#13#10#13#10, [p1, p2, transferred / (1024 * 1024), (transferred / (1024 * 1024)) / clientsCount, (transferred / (1024 * 1024)) / interrupted] ) );
						end;
					end;
				end;

			with stats[ 4 ] do
				begin
				addText( #9#9#9'Clients whith both interrupted and failed sessions:'#13#10, [fsBold] );
				if clientsCount = 0 then
					addText( #9#9#9'None'#13#10#13#10 )
				else
					begin
					addText( format( #9'%f%%'#9'%f%%'#9'%u clients'#13#10, [100 * (clientsCount / clientsUsed), 100 * (clientsCount / nClients), clientsCount] ) );
					addText( format( #9'%f%%'#9'%f%%'#9'%u sessions	(%f per client)'#13#10, [100 * ((interrupted + failed) / sessionsUsed), 100 * ((interrupted + failed) / nSessions), interrupted + failed, (interrupted + failed) / clientsCount] ) );
					if calcTransfers then
						begin
						if transferredTotal <> 0 then p1 := 100 * (transferred / transferredTotal) else p1 := nan;
						if transferredGroup <> 0 then p2 := 100 * (transferred / transferredGroup) else p2 := nan;
						addText( format( #9'%f%%'#9'%f%%'#9'%fMB	(%fMB/client;	%fMB/session)'#13#10, [p1, p2, transferred / (1024 * 1024), (transferred / (1024 * 1024)) / clientsCount, (transferred / (1024 * 1024)) / (interrupted + failed)] ) );
						end;
					addText( format( #9#9#9'%f%%'#9'Interrupted:	%u sessions	(%f per client)'#13#10, [100 * (interrupted / (interrupted + failed)), interrupted, interrupted / clientsCount] ) );
					addText( format( #9#9#9'%f%%'#9'Failed:	%u sessions	(%f per client)'#13#10#13#10, [100 * (failed / (interrupted + failed)), failed, failed / clientsCount] ) );
					end;
				end;

			with stats[ 5 ] do
				begin
				addText( #9#9#9'Clients whith only failed sessions:'#13#10, [fsBold] );
				if clientsCount = 0 then
					addText( #9#9#9'None'#13#10 )
				else
					begin
					addText( format( #9'%f%%'#9'%f%%'#9'%u clients'#13#10, [100 * (clientsCount / clientsUsed), 100 * (clientsCount / nClients), clientsCount] ) );
					addText( format( #9'%f%%'#9'%f%%'#9'%u sessions	(%f per client)'#13#10, [100 * (failed / sessionsUsed), 100 * (failed / nSessions), failed, failed / clientsCount] ) );
					end;
				end;
			end;
		end;

	statsBox.selStart := 0;

	finally
		if progressMin = 0 then progressBar.position := 0;
		screen.cursor := cr;
	end;
end;

procedure tmainForm.aFileOpenAccept(Sender: TObject);
begin
	loadLog( '', aFileOpen.dialog.files );
end;

procedure tmainForm.uUpdateStats(Sender: TObject);
begin
	calcStats( true );
end;

procedure tmainForm.dUpdateStats(Sender: TObject);
begin
	calcStats( false );
end;

procedure tmainForm.uMinSessionsBoxChange(Sender: TObject);
begin
	if uMinSessionsBox.minValue = uMinSessionsBox.maxValue then
		uMinSessionsBox.value := 1;
	calcStats( true );
end;

procedure tmainForm.dMinSessionsBoxChange(Sender: TObject);
begin
	if dMinSessionsBox.minValue = dMinSessionsBox.maxValue then
		dMinSessionsBox.value := 1;
	calcStats( false );
end;

procedure tmainForm.uPrevNextSessionUpdate(Sender: TObject);
begin
	aUNextSession.enabled := (tabs.activePageIndex = 0);
	aUPrevSession.enabled := (tabs.activePageIndex = 0);
end;

procedure tmainForm.aUNextSessionExecute(Sender: TObject);
begin
	if uSessionsBox.itemIndex < pred( uSessionsBox.count ) then
		begin
		uSessionsBox.itemIndex := uSessionsBox.itemIndex + 1;
		uSessionsBoxClick( nil );
		end;
end;

procedure tmainForm.aUPrevSessionExecute(Sender: TObject);
begin
	if uSessionsBox.itemIndex > 0 then
		begin
		uSessionsBox.itemIndex := uSessionsBox.itemIndex - 1;
		uSessionsBoxClick( nil );
		end;
end;

procedure tmainForm.dPrevNextSessionUpdate(Sender: TObject);
begin
	aDNextSession.enabled := (tabs.activePageIndex = 2);
	aDPrevSession.enabled := (tabs.activePageIndex = 2);
end;

procedure tmainForm.aDNextSessionExecute(Sender: TObject);
begin
	if dSessionsBox.itemIndex < pred( dSessionsBox.count ) then
		begin
		dSessionsBox.itemIndex := dSessionsBox.itemIndex + 1;
		dSessionsBoxClick( nil );
		end;
end;

procedure tmainForm.aDPrevSessionExecute(Sender: TObject);
begin
	if dSessionsBox.itemIndex > 0 then
		begin
		dSessionsBox.itemIndex := dSessionsBox.itemIndex - 1;
		dSessionsBoxClick( nil );
		end;
end;

procedure tmainForm.AppEventsShowHint(var HintStr: String; var CanShow: Boolean; var HintInfo: THintInfo);
begin
	hintStr := stringReplace( stringReplace( stringReplace( stringReplace( hintStr, '\\', #1, [rfReplaceAll] ), '\n', #13#10, [rfReplaceAll] ), #1, '\', [rfReplaceAll] ), ';   ', #13#10, [rfReplaceAll] );
end;

procedure tmainForm.tabsChange(Sender: TObject);
begin
	aUNextSession.shortcut := tShortcut( 0 );
	aUPrevSession.shortcut := tShortcut( 0 );
	aDNextSession.shortcut := tShortcut( 0 );
	aDPrevSession.shortcut := tShortcut( 0 );
	if tabs.activePageIndex = 0 then
		begin
		aUNextSession.shortcut := nextSessionShcut;
		aUPrevSession.shortcut := prevSessionShcut;
		end
	else if tabs.activePageIndex = 2 then
		begin
		aDNextSession.shortcut := nextSessionShcut;
		aDPrevSession.shortcut := prevSessionShcut;
		end;
end;

procedure tmainForm.noticeBtnClick(Sender: TObject);
begin
	noticePanel.visible := false;
end;

procedure tmainForm.noticePanelResize(Sender: TObject);
begin
	if noticePanel.visible then
		noticeBtn.left := (noticePanel.width - noticeBtn.width) div 2;
end;

procedure tmainForm.noticePanelInit;

	procedure addText( const newText: string; style: tFontStyles = [] );
	begin
		noticeBox.selAttributes.style := style;
		noticeBox.selText := newText + #13#10;
	end;

begin
	if noticePanel.visible then
		begin
		noticeBox.clear;
		addText( 'Important note', [fsBold, fsUnderline] );
		addText( #13#10 );
		addText( 'This program is mainly designed to help you optimizing your eMule configuration.' );
		addText( 'It is in no way a tool to spot supposed leechers.' );
		addText( #13#10 );
		addText( 'If you think you have too many failed or interrupted download sessions, please first look at your upload statistics and try to improve them.' );
		addText( 'As you will see, many clients cannot correctly download from you... And for most of them, unfortunately, the only thing you can do is to let them try to download from you, even if they cannot upload to you...' );
		end;
end;

procedure tmainForm.noNoticeBoxClick(Sender: TObject);
var
	ini: tIniFile;
begin
	ini := tIniFile.create( changeFileExt( application.exeName, '.ini' ) );
	try
		ini.writeBool( 'Options', 'Notice', false );
		finally ini.free;
		end;
end;

procedure tmainForm.aHideFiltersExecute(Sender: TObject);
begin
	uStatsSettingsPanel.visible := not aHideFilters.checked;
	uSplitter.visible := not aHideFilters.checked;
	uSplitter.top := uStatsSettingsPanel.height;
	dStatsSettingsPanel.visible := not aHideFilters.checked;
	if tabs.activePage = uStatsTab then
		begin
		if aHideFilters.checked then uStatsBox.setFocus
		else uMinSessionsBox.setFocus;
		end
	else if tabs.activePage = dStatsTab then
		begin
		if aHideFilters.checked then dStatsBox.setFocus
		else dMinSessionsBox.setFocus;
		end;
end;

procedure tmainForm.FormResize(Sender: TObject);
begin
	if uStatsTab.height - uStatsSettingsPanel.height - uSplitter.height < uSplitter.minSize then
		begin
		uStatsSettingsPanel.height := uStatsTab.height - uSplitter.minSize - uSplitter.height;
		end;
end;

procedure tmainForm.uSoftBoxChange(Sender: TObject);
begin
	if (uSoftBox.itemIndex >= 0) and (uSoftBox.items.indexOf( uSoftBox.text ) >= 0) then calcStats( true );
end;

procedure tmainForm.dSoftBoxChange(Sender: TObject);
begin
	if (dSoftBox.itemIndex >= 0) and (dSoftBox.items.indexOf( dSoftBox.text ) >= 0)  then calcStats( false );
end;

procedure tmainForm.uSoftBoxKeyPress(Sender: TObject; var Key: Char);
begin
	if key = #13 then
		begin
		if uSoftBox.items.indexOf( uSoftBox.text ) < 0 then
			begin
			uSoftBox.items.add( uSoftBox.text );
			dSoftBox.items.add( uSoftBox.text );
			uSoftBox.itemIndex := uSoftBox.items.indexOf( uSoftBox.text );
			end;
		calcStats( true );
		end;
end;

procedure tmainForm.dSoftBoxKeyPress(Sender: TObject; var Key: Char);
begin
	if key = #13 then
		begin
		if dSoftBox.items.indexOf( dSoftBox.text ) < 0 then
			begin
			dSoftBox.items.add( dSoftBox.text );
			uSoftBox.items.add( dSoftBox.text );
			dSoftBox.itemIndex := dSoftBox.items.indexOf( dSoftBox.text );
			end;
		calcStats( false );
		end;
end;

procedure tmainForm.clientsBoxDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
	clients: tClients;
	i: integer;
	dw: dword;
	s: string;
begin
	if control = uClientsBox then clients := uClients
	else clients := dClients;
	with (control as tListBox).canvas do
		begin
		fillRect( rect );
		{ 25 apr 07: Optimizations >>> }
		{ >>> 20 may 07: Clients identification options }
		if dynIPDetection and clients.dynIP[ index ] then
			textOut( rect.left + 2, rect.top, rsDynIP )
		else
			begin
		{ <<< 20 may 07: Clients identification options }
			dw := clients.IP[ index ];
			s := '';
			for i := 0 to 3 do
				begin
				s := intToStr( dw and $FF ) + s;
				if i < 3 then
					begin
					s := '.' + s;
					dw := dw shR 8;
					end;
				end;
			textOut( rect.left + 2, rect.top, s );
		{ >>> 20 may 07: Clients identification options }
			end;
		{ <<< 20 may 07: Clients identification options }
		if clients.ID[ index ].lowID then
			begin
			{ 20 may 07: Clients identification options >>> }
			if replaceLowID then
				textOut( rect.left + 97, rect.top, rsLowID )
			else
				begin
			{ <<< 20 may 07: Clients identification options }
				dw := clients.ID[ index ].IP;
				s := '';
				for i := 0 to 3 do
					begin
					s := intToStr( dw and $FF ) + s;
					if i < 3 then
						begin
						s := '.' + s;
						dw := dw shR 8;
						end;
					end;
				textOut( rect.left + 97, rect.top, intToStr( int64( clients.ID[ index ].ID ) ) + strLowID1 + s );
			{ 20 may 07: Clients identification options >>> }
				end;
			{ <<< 20 may 07: Clients identification options }
			end;
{ old code:
		textOut( rect.left + 2, rect.top, clients.IP[ index ] );
		textOut( rect.left + 97, rect.top, clients.ID[ index ] );
}		{ <<< 25 apr 07: Optimizations }
		textOut( rect.left + 250, rect.top, clients.pseudo[ index ] );
		textOut( rect.left + 250 + (rect.right - rect.left - 250) * 3 div 5, rect.top, clients.software[ index ] );
		end;
end;

procedure tmainForm.aSortClients(Sender: TObject);
var
	cr: tCursor;
begin
	cr := screen.cursor;
	screen.cursor := crHourGlass;
	try
		aSortByIP.checked := false;
		aSortByPseudo.checked := false;
		aSortBySoftware.checked := false;
		tAction( sender ).checked := true;
		if aSortByIP.tag > tAction( sender ).tag then aSortByIP.tag := aSortByIP.tag - 1;
		if aSortByPseudo.tag > tAction( sender ).tag then aSortByPseudo.tag := aSortByPseudo.tag - 1;
		if aSortBySoftware.tag > tAction( sender ).tag then aSortBySoftware.tag := aSortBySoftware.tag - 1;
		tAction( sender ).tag := 2;
		dynIPDetectionDone := true; { 20 may 07: Clients identification options }
		{ 25 apr 07: Optimizations >>> }
		uClients.sort( sortClients );
		uClientsBox.count := uClients.count; { uses a virtual list box, now }
		dClients.sort( sortClients );
		dClientsBox.count := dClients.count; { uses a virtual list box, now }
{ old code:
		uClients.customSort( sortClients );
		uClientsBox.items.assign( uClients );
		dClients.customSort( sortClients );
		dClientsBox.items.assign( dClients );
}		{ <<< 25 apr 07: Optimizations }
		finally screen.cursor := cr;
		end;
end;

{ 22 apr 07: Stats for selected clients >>> }
procedure tmainForm.uStatsTabExit(Sender: TObject);
begin
	uClientsBox.tag := 0;
end;

procedure tmainForm.uStatsTabEnter(Sender: TObject);
begin
	if uSelClientsBox.checked and (uClientsBox.tag <> 0) then calcStats( true );
end;

procedure tmainForm.dStatsTabExit(Sender: TObject);
begin
	dClientsBox.tag := 0;
end;

procedure tmainForm.dStatsTabEnter(Sender: TObject);
begin
	if dSelClientsBox.checked and (dClientsBox.tag <> 0) then calcStats( false );
end;
{ <<< 22 apr 07: Stats for selected clients }

{ 20 may 07: Clients identification options >>> }
procedure tmainForm.aClientsIdOptionsExecute(Sender: TObject);
var
	ini: tIniFile;
	s: string;
begin
	clientsIdOptionsForm := tClientsIdOptionsForm.create( self );
	with clientsIdOptionsForm do
		begin
		try
			replRndWithXXXBtn.checked := replaceRndCharsWithXXX;
			minRndCharsBox.value := minRndChars;
			maxRndCharsBox.value := maxRndChars;
			s := stringReplace( replaceRndCharsExceptions.text, #13#10, '][', [rfReplaceAll] );
			exceptionsBox.text := '[' + copy( s, 1, length( s ) - 1 );
			replIDBtn.checked := replaceLowID;
			dynIPBtn.checked := dynIPDetection;
			s := stringReplace( uselessPseudos.text, #13#10, ' ', [rfReplaceAll] );
			uselessPseudosBox.text := copy( s, 1, length( s ) - 1 );
			significantSizeBox.value := significantSize;
			if showModal = mrOk then
				begin
				replaceRndCharsWithXXX := replRndWithXXXBtn.checked;
				minRndChars := minRndCharsBox.value;
				maxRndChars := maxRndCharsBox.value;
				s := stringReplace( exceptionsBox.text, '][', #13#10, [rfReplaceAll] );
				replaceRndCharsExceptions.text := copy( s, 2, length( s ) - 2 );
				replaceLowID := replIDBtn.checked;
				dynIPDetection := dynIPBtn.checked;
				uselessPseudos.text := stringReplace( uselessPseudosBox.text, ' ', #13#10, [rfReplaceAll] );
				significantSize := significantSizeBox.value;

				ini := tIniFile.create( changeFileExt( application.exeName, '.ini' ) );
				try
					ini.writeBool( 'ClientsIdOptions', 'ReplaceRndChars', replaceRndCharsWithXXX );
					ini.writeInteger( 'ClientsIdOptions', 'minRndChars', minRndChars );
					ini.writeInteger( 'ClientsIdOptions', 'maxRndChars', maxRndChars );
					ini.writeString( 'ClientsIdOptions', 'Exceptions', exceptionsBox.text );
					ini.writeBool( 'ClientsIdOptions', 'ReplaceLowID', replaceLowID );
					ini.writeBool( 'ClientsIdOptions', 'dynIPDetection', dynIPDetection );
					ini.writeString( 'ClientsIdOptions', 'uselessPseudos', uselessPseudosBox.text );
					ini.writeInteger( 'ClientsIdOptions', 'significantSize', significantSize );
					finally ini.free;
					end;
				end;
			finally free;
			end;
		end;
end;
{ <<< 20 may 07: Clients identification options }

end.
